#!/usr/bin/perl 

require "./gifdog.pl";
require "./pngren.pl";
require "./leaf.pl";

my %FORM = lib::form_decode();

if($FORM{'outimg'}) # png,gifC[W̒ڏo
{ 
   print "Content-type: image/$FORM{'outimg'}\n\n"; #image/png #image/gif #image/jpeg
}
else 
{
   print "Content-type: text/html\n\n";
   lib::print_header(); 
}

if($FORM{'sgf'}) # /o
{    
    @data = ($FORM{'sgf'}, 
             $FORM{'fix'} ? 1 : 0, 
             $FORM{'mov'} ? 1 : 0,
             $FORM{'num'} ? 1 : 0,
             $FORM{'outimg'} ? 1 : 0,
             $FORM{'pngdir'}  ? $FORM{'pngdir'}  : 0,
             $FORM{'pngname'} ? $FORM{'pngname'} : 0,
             $FORM{'gifdir'}  ? $FORM{'gifdir'}  : 0,
             $FORM{'gifname'} ? $FORM{'gifname'} : 0,
             $FORM{'endmark'} ? 1 : 0,
             $FORM{'usrdir'}  ? $FORM{'usrdir'}  : 0, 
             $FORM{'xMin'}  ? $FORM{'xMin'}  : 0,
             $FORM{'yMin'}  ? $FORM{'yMin'}  : 0,
             $FORM{'xMax'}  ? $FORM{'xMax'}  : 0,
             $FORM{'yMax'}  ? $FORM{'yMax'}  : 0
             );

    foreach (('pngren', 'gifdog', 'gif', 'txt')) 
    {
        if($FORM{$_}) { leaf::sgf2dia(@data, $_); } 
    }  
}

if(!$FORM{'outimg'}) { print qq|</body></html>|; }

exit;


package lib;

sub form_decode 
{
    my $buf;
    if($ENV{'REQUEST_METHOD'} eq 'POST') 
    {
        read STDIN, $buf, $ENV{'CONTENT_LENGTH'};
    }
    else{ $buf = $ENV{'QUERY_STRING'} }
    
    return decode($buf);
}

sub decode 
{
    my $buf = $_[0];
    my %TMP;
    foreach (split /&/, $buf) 
    {
        my ($key, $val) = split /=/;
        $val =~ tr/+/ /;
        $val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        if(defined $TMP{$key}){ $TMP{$key} .= ",$val"; }
        else { $TMP{$key}  = $val; }
    }
    return %TMP;
}

#sub_print_header  HTML ̃wb_
sub print_header 
{
   print "<html><head> <title>SGF to Diagram</title>";
   print "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html;CHARSET=Shift_JIS\">";
   print "</head><body> <h1>SGF to Diagram</h1><br>";
}

