;#--------------------------------------------------------------------
##
##  PerlpPNGACu pngren.pl version 2.0.1 (2004/ 6/22)
##
##
##  Copyright (c) 2000-2004 
##      http://www.aurora.dti.ne.jp/~zom/Counter/
##
##  PNGACúAȉ2t@C琬藧Ă܂B
##    Epngren.pl  i{́j
##    Epngrenhz.pli{̂Ă΂qCuj
##  g̓A[JCɓĂreadme.txtɋLڂĂ܂B
##
##  K̎𔺂ʍĔzzEɂẮA̒쌠\c
##  ƂɁARɍsĂ܂܂B
##
##--------------------------------------------------------------------
##
##  
##    C^[[XPNG͘Ał܂B
##    65536oCgȏ̉摜͘Ał܂B
##
##  ŐVł̓恡
##    http://www.aurora.dti.ne.jp/~zom/Counter/
##
##--------------------------------------------------------------------


#use strict;	# debug.
#use warnings;	# debug.


package pngren;


# ݒB
$pngren::version = 2.0.1;
$pngren::koLibrary   = 'pngrenhz.pl';
$pngren::zlibLibrary = 'pryzlib.pl';
$pngren::cacheChunk  = 'prYC';		# 0x25-0x28 (4bytes)
$pngren::cacheVersion = "\x02\0\0";	# 0x29-0x2b (3bytes)
$pngren::USEMYZLIB = 0;
$pngren::crcTable  = ();
$pngren::errorMessage = '';
$pngren::HEADER_SIZE  = 0x30;

$pngren::FOOTER_SIZE     = 0x18;
$pngren::FOOTER_BETAINFO = -8;
$pngren::FOOTER_BETA     = -16;

$pngren::CACHEONLY   = 0;
$pngren::IDAT_ZLIB   = 1 << 0;
$pngren::IDAT_FILTER = 1 << 1;
$pngren::INC_BD8     = 1 << 2;
$pngren::CONV_P2C    = 1 << 3;
$pngren::CONV_G2C    = 1 << 4;

$pngren::CONV_WSCs   = 1 << 8;
$pngren::DEC_BD8     = 1 << 9;
$pngren::INC_BD16    = 1 << 10;

$pngren::MAKEALPHA   = 1 << 16;
$pngren::DELALPHA    = 1 << 17;
$pngren::ONLY6       = 1 << 18;
$pngren::tRNS_DROP   = 1 << 19;
$pngren::bKGD_DROP   = 1 << 20;

$pngren::AUTO        = 1 << 24;
$pngren::IGNORECACHE = 1 << 25;
$pngren::MODIFYCACHE = 1 << 26;

$pngren::USEUNIPLTE = 1 << 29;
$pngren::PARSEONLY  = 1 << 30;
$pngren::LOOSECRC   = 1 << 31;


# ʖ`B
$pngren::ALL = $pngren::IDAT_FILTER | $pngren::IDAT_ZLIB | $pngren::INC_BD8 | $pngren::CONV_P2C;
$pngren::ALLWSCs = $pngren::ALL | $pngren::CONV_G2C | $pngren::CONV_WSCs;
$pngren::ALL24   = $pngren::ALL | $pngren::CONV_G2C | $pngren::DEC_BD8; 
$pngren::ALL48   = $pngren::ALL | $pngren::CONV_G2C | $pngren::INC_BD16; 
$pngren::ALL32   = $pngren::ALL24 | $pngren::MAKEALPHA; 
$pngren::ALL64   = $pngren::ALL48 | $pngren::MAKEALPHA; 
$pngren::ALL24  |= $pngren::DELALPHA;
$pngren::ALL48  |= $pngren::DELALPHA;

$pngren::ALLAUTO = $pngren::ALL | $pngren::AUTO;
$pngren::ALLAUTOWSCs = $pngren::ALLAUTO | $pngren::CONV_G2C | $pngren::CONV_WSCs;
$pngren::ALLAUTO24   = $pngren::ALLAUTO | $pngren::CONV_G2C | $pngren::DEC_BD8; 
$pngren::ALLAUTO48   = $pngren::ALLAUTO | $pngren::CONV_G2C | $pngren::INC_BD16; 
$pngren::ALLAUTO32   = $pngren::ALLAUTO24 | $pngren::MAKEALPHA; 
$pngren::ALLAUTO64   = $pngren::ALLAUTO48 | $pngren::MAKEALPHA; 
$pngren::ALLAUTO24  |= $pngren::DELALPHA;
$pngren::ALLAUTO48  |= $pngren::DELALPHA;

$pngren::RECACHE = $pngren::IGNORECACHE;
$pngren::REDO    = $pngren::IGNORECACHE;


&MakeCRCTable;


# MIMEwb_óB
sub OutMIME
{
	binmode(STDOUT);
	print "Content-Type: $_[0]\n\n";
}


# `NóB
sub OutChunk
{
	my($chunkName, $chunkData, $bCalcOnly) = @_;
	my($crc) = 0xffffffff;

	if(!$bCalcOnly)
	{
		print pack('N', length($$chunkData));
		print $$chunkName;
		print $$chunkData;
	}
	foreach(unpack('C4', $$chunkName))
	{
		$crc = $pngren::crcTable[($crc ^ $_) & 0xff] ^ ($crc >> 8);
	}
	foreach(unpack('C*', $$chunkData))
	{
		$crc = $pngren::crcTable[($crc ^ $_) & 0xff] ^ ($crc >> 8);
	}
	$crc = ~$crc;
	print pack('N', $crc) if(!$bCalcOnly);
	return $crc;
}


# CRC\̍쐬B
sub MakeCRCTable
{
	my($i, $j, $crc);

	$pngren::crcTable = ();
	for($i = 0; $i < 256; $i++)
	{
		$crc = $i;
		for($j = 0; $j < 8; $j++)
		{
			if($crc & 1)
			{
				$crc = 0xedb88320 ^ ($crc >> 1);
			}
			else
			{
				$crc = $crc >> 1;
			}
		}
		$pngren::crcTable[$i] = $crc;
	}
}


# LbV̗LE@[W𒲂ׂB
sub CheckCache
{
	my($header) = @_;

	return  0 if(substr($_[0], 0x25, length($_[1])) ne $_[1]);
	return -1 if(substr($_[0], 0x29, length($_[2])) ne $_[2]);
	return unpack('N', substr($_[0], 0x2c, 4));
}


# gl֐B
sub CachePNG
{
	eval { require $pngren::koLibrary; };
	if($@)
	{
		$pngren::errorMessage = $@;
		return 1;
	}
	return &_CachePNG(@_);
}


# PNGB
sub PngRen
{
	my($narabi, $flags, $bTate, $headers) = @_;
	my($wholeWidth, $wholeHeight, $prevCI, $cacheNumber) = (0, 0, 0, 0);
	my(%bHasRead, @cacheNarabi, @periodCount, @periodBytes) = ();
	my(@png, @width, @height, @widthBytes) = ();
	my($png, $width, $height, $IDATBetaOffset, $bytesPerPixel, $bitDepth, $colourType, $colourInfo);
	my($pngFile, $pngData, $header, $result, $readOffset);
	my($maxWidth, $maxHeight, $widthBytes, $maxBytesPerLine, $y, $size, $count);
	my($chunkData, $hozhoChunks, $newBlock);
	my($s1, $s2, $newS1, $newS2, $fusoku, $filter, $blockSize, $chunkSize);

	$pngren::errorMessage = '';
	if(!$narabi || $#$narabi < 0)
	{
		$pngren::errorMessage = '̉摜AXgB';
		return 7;
	}

	$hozhoChunks = '';
	$maxWidth = $maxHeight = 0;
	foreach $pngFile (@$narabi)
	{
		if(!$bHasRead{$pngFile})
		{
			$pngData = \$png[$cacheNumber];

			$size = 0;
			if(!open(IN, $pngFile))
			{
				$pngren::errorMessage = qq|"$pngFile" ȂB|;
				return 2;
			}
			binmode(IN);
			seek(IN, 0, 0);
			if(read(IN, $header, $pngren::HEADER_SIZE) == $pngren::HEADER_SIZE)
			{
				$size = &CheckCache($header, $pngren::cacheChunk, $pngren::cacheVersion);
			}
			if($size > 0 && !($flags & $pngren::IGNORECACHE))
			{
				read(IN, $$pngData, $size);
				if($cacheNumber == 0)
				{
					$size = unpack('N', substr($$pngData, -4, 4)) - 4;
					read(IN, $hozhoChunks, $size);
				}
				close(IN);
			}
			elsif($flags & ($pngren::IGNORECACHE | $pngren::AUTO))
			{
				seek(IN, 0, 0);
				$size = -s $pngFile;
				read(IN, $$pngData, $size);
				close(IN);

				eval { require $pngren::koLibrary; };
				if($@)
				{
					$pngren::errorMessage = $@;
					return 1;	# CuȂACuŃG[B
				}

				$result = &BetaPNG($pngData, $flags);
				if($result >= 1)
				{
#					$pngren::errorMessage = "Result code: $result";
#					return 4;	# PNGɖ肠B
					return $result;
				}

				$IDATBetaOffset = unpack('N', substr($$pngData, $pngren::FOOTER_BETA, 4));
				$hozhoChunks = substr($$pngData, 0x21, $IDATBetaOffset - 0x29)
					if($cacheNumber == 0);

				substr($$pngData, 0, $IDATBetaOffset) = '';
			}
			else
			{
				close(IN);
				$pngren::errorMessage = 'płLbVȂB';
				return 3;
			}

			($width, $height) = unpack('N2', substr($header, 0x10, 8));
			($bitDepth, $colourType, $bytesPerPixel)
				= unpack('C3', substr($$pngData, $pngren::FOOTER_BETAINFO, 3));

			$colourInfo = ($bitDepth << 16) | ($colourType << 8) | $bytesPerPixel;
			if($prevCI && $prevCI != $colourInfo)
			{
				$pngren::errorMessage = sprintf("$cacheNumberԖڂ̉摜 $pngFile [$colourType/$bitDepth/$bytesPerPixel] ܂ł̂ [%d/%d/%d] ƕsB", ($prevCI >> 8) & 0xff, ($prevCI >> 16) & 0xff, $prevCI & 0xff);
				return 5;
			}

			$maxWidth  = $width  if($maxWidth  < $width);
			$maxHeight = $height if($maxHeight < $height);

			$width[$cacheNumber]  = $width;
			$height[$cacheNumber] = $height;
			$widthBytes[$cacheNumber] = $width * $bytesPerPixel;

			push(@cacheNarabi, $cacheNumber++);
			$bHasRead{$pngFile} = $cacheNumber;	# 0邽1ƂB

			$prevCI = $colourInfo;
		}
		else
		{
			push(@cacheNarabi, $bHasRead{$pngFile} - 1);
		}
		$wholeWidth  += $width[$bHasRead{$pngFile} - 1];
		$wholeHeight += $height[$bHasRead{$pngFile} - 1];
	}

	$maxBytesPerLine = $maxWidth * $bytesPerPixel + 1;

	if(!$bTate)
	{
		$wholeHeight = $maxHeight;
	}
	else
	{
		$wholeWidth  = $maxWidth;
	}

# ̓G[֎~B

#	&MakeCRCTable;
	binmode(STDOUT);
	print $$headers if($headers && $$headers ne '');
	print "\x89PNG\x0d\x0a\x1a\x0a";

	$chunkData = pack('N2C2', $wholeWidth, $wholeHeight, $bitDepth, $colourType)."\0\0\0";
	&OutChunk(\'IHDR', \$chunkData);

	# IDAT̑Oɂ⏕`NoB
	print $hozhoChunks;

	# IDAT̃x^f[^쐬B
#	print "\0\0\0\x07IDATx\x01\0\0\0\xFF\xFF\xE3\xAB\x84\x32";
	print "\0\0\0\x02IDATx\x01\xEC\x1A\x7E\xD2";
	$filter = "\0\0\0\x06IDAT\0\x01\0\xFE\xFF\0\x21\xE8\x93\xD8";
	$s1 = 1;
	$s2 = 0;
	if(!$bTate)
	{
		for($y = 0; $y < $wholeHeight; $y++)
		{
			print $filter;
			$s2 += $s1;
			$s2 -= 65521 if($s2 > 65520);

			foreach $cacheNumber (@cacheNarabi)
			{
				$widthBytes = $widthBytes[$cacheNumber];
				$chunkSize  = $widthBytes + 17;
				$blockSize  = $widthBytes + 21;
				# len(4) + name(4) + crc(4) + BFINAL/LEN/NLEN(5) = 17 + s1/s2(4) = 21.

				$chunkData  = "\0".pack('v2', $widthBytes, ~$widthBytes);
				$chunkData .= "\0" x $widthBytes;

				if($y < $height[$cacheNumber])
				{
					$readOffset = $blockSize * $y;
					print substr($png[$cacheNumber], $readOffset, $chunkSize);
					($newS1, $newS2) = unpack('n2', substr($png[$cacheNumber], $readOffset + $chunkSize, 4));
				}
				else
				{
					&OutChunk(\'IDAT', \$chunkData);
					$newS1 = $newS2 = 0;
				}
				$fusoku = $s1;
#				$fusoku -= 65521 if($fusoku > 65520);

				$s1 += $newS1;
				$s1 -= 65521 if($s1 > 65520);

				$s2 += $fusoku * $widthBytes + $newS2;
				# őłfusoku(65520) * widthBytes(65535) + newS2(65520) + s2(65520)
				# = 65520 * 65537 = 4293984240(0xFFF0FFF0) ̂ŁA32bitsɎ܂B
				$s2 %= 65521;
			}
		}
	}
	else	# cɂȂB
	{
		foreach $cacheNumber (@cacheNarabi)
		{
			$widthBytes = $widthBytes[$cacheNumber];
			$chunkSize  = $widthBytes + 17;
			$blockSize  = $widthBytes + 21;
			$readOffset = 0;
			$height     = $height[$cacheNumber];

			$width = $maxBytesPerLine - $widthBytes - 1;
			$chunkData  = "\0".pack('v2', $width, ~$width);
			$chunkData .= "\0" x $width;

			for($y = 0; $y < $height; $y++)
			{
				print $filter;
				$s2 += $s1;
				$s2 -= 65521 if($s2 > 65520);

				print substr($png[$cacheNumber], $readOffset, $chunkSize);
				($newS1, $newS2) = unpack('n2', substr($png[$cacheNumber], $readOffset + $chunkSize, 4));

				$fusoku = $s1;

				$s1 += $newS1;
				$s1 -= 65521 if($s1 > 65520);

				$s2 += $fusoku * $widthBytes + $newS2;
				$s2 %= 65521;

				if($width)
				{
					&OutChunk(\'IDAT', \$chunkData);

					$s2 += $s1 * $width;	# ő65520 + 65520 * 65535
					$s2 %= 65521;			# = 4293918720(0xFFF00000).
				}
				$readOffset += $blockSize;
			}
		}
	}
	$chunkData = "\x01\0\0\xFF\xFF".pack('n2', $s2, $s1);
	&OutChunk(\'IDAT', \$chunkData);

	# IEND.
	print "\0\0\0\0IEND\xaeB`\x82";

	return 0;
}
1;
__END__

;#--------------------------------------------------------------------
##
##  牺͍폜ĂSł
##
##--------------------------------------------------------------------
##
##  XV
##
##  Version 2.0 beta1 (2004/ 6/13)
##      2.ẍʌJŁB
##
##  Version 2.0 (2004/ 6/20)
##      CRČvZA܂ł̂悤ɉ摜Aɍŝł͂ȂA
##      f[^x^f[^鎞ɍs悤ɂAAɂ͗\߃u
##      bNƂɎZoꂽCRCZΗǂɂȂ悤Ɏd
##      lύXBɂ摜Aׂ̕yB
##
##  Version 2.0.1 (2004/ 6/22)
##      $pngren::versionϐǉB
##
##--------------------------------------------------------------------
