;#--------------------------------------------------------------------
##
##  PNGACu"pngren.pl"p⏕Cu
##                    pngrenhz.pl version 1.0.1 (2004/ 6/22)
##
##  Copyright (c) 2000-2004 
##      http://www.aurora.dti.ne.jp/~zom/Counter/
##
##  PNGACúAȉ2t@C琬藧Ă܂B
##    Epngren.pl  i{́j
##    Epngrenhz.pli{̂Ă΂qCuj
##  g̓A[JCɓĂreadme.txtɋLڂĂ܂B
##
##  K̎𔺂ʍĔzzEɂẮA̒쌠\c
##  ƂɁARɍsĂ܂܂B
##
##--------------------------------------------------------------------
##
##  
##    C^[[XPNG͘Ał܂B
##    65536oCgȏ̉摜͘Ał܂B
##
##  ŐVł̓恡
##    http://www.aurora.dti.ne.jp/~zom/Counter/
##
##--------------------------------------------------------------------


#use strict;	# debug.
#use warnings;	# debug.


package pngren;
# pngren.plrequire邱ƂO₯ǁAꉞ܂ȂB


sub CheckValidity
{
	my($bitDepth, $colourType) = @_;

	if($colourType == 2 || $colourType == 4 || $colourType == 6)
	{
		return 1 if($bitDepth == 8 || $bitDepth == 16);
	}
	elsif($colourType == 3)
	{
		return 1 if($bitDepth == 1 || $bitDepth == 2 || $bitDepth == 4
			|| $bitDepth == 8);
	}
	elsif($colourType == 0)
	{
		return 1 if($bitDepth == 1 || $bitDepth == 2 || $bitDepth == 4
			|| $bitDepth == 8 || $bitDepth == 16);
	}
	return 0;
}


sub FilterSub
{
	my($byte, $lineOffset, $bpp, $ima, $mae) = @_;

	$lineOffset -= $bpp;
	$byte += $ima->[$lineOffset] if($lineOffset >= 0);
	return $byte;
}


sub FilterUp
{
	my($byte, $lineOffset, $bpp, $ima, $mae) = @_;

	return $byte + $mae->[$lineOffset];
}


sub FilterAverage
{
	my($byte, $lineOffset, $bpp, $ima, $mae) = @_;
	my($maue) = $mae->[$lineOffset];

	$lineOffset -= $bpp;
	$maue += $ima->[$lineOffset] if($lineOffset >= 0);
	$maue >>= 1;
	return $byte + $maue;
}


sub FilterPaeth
{
	my($byte, $lineOffset, $bpp, $ima, $mae) = @_;
	my($hidari, $hidariue) = (0, 0);
	my($maue) = $mae->[$lineOffset];
	my($p, $pa, $pb, $pc);

	$lineOffset -= $bpp;
	if($lineOffset >= 0)
	{
		$hidari   = $ima->[$lineOffset];
		$hidariue = $mae->[$lineOffset];
	}
	$p = $hidari + $maue - $hidariue;
	$pa = abs($p - $hidari);
	$pb = abs($p - $maue);
	$pc = abs($p - $hidariue);

	return $byte + $hidari if($pa <= $pb && $pa <= $pc);
	return $byte + $maue   if($pb <= $pc);
	return $byte + $hidariue;
	# timetheseɂƁA3ZqgƋpĒxȂB
}


sub Convert8bits
{
	my($newIDAT, $bitDepth, $width, $betaData) = @_;
	my($pixelsPerByte, $mask, $x, $count, $shiftBits, $pixels);

	$$newIDAT = '';

	$pixelsPerByte = 8 / $bitDepth;
	$mask = (1 << $bitDepth) - 1;
	$x = 0;
	foreach $pixels (unpack('C*', $$betaData))
	{
		$count = $pixelsPerByte;
		$shiftBits = 8;
		while($count--)
		{
			$shiftBits -= $bitDepth;
			$$newIDAT  .= pack('C', ($pixels >> $shiftBits) & $mask);
			$x++;
			$count = $x = 0 if($x >= $width);
		}
	}
}


sub Sashikae
{
	my($png, $target, $newData, $newLength) = @_;
	my($targetOffset) = $target.'Offset';
	my($targetLength) = $target.'Length';
	my($pngData) = $png->{'data'};
	my($offset, $length, $chunkName);

	$newLength = length($$newData) if(!$newLength);

	if($target eq 'IDATBeta')
	{
		$offset = $png->{$targetOffset};
		return 0 if(!$offset);
		$length = $png->{$targetLength};

		substr($$pngData, $offset, $length) = $$newData;

		$png->{$targetLength} = $newLength;
		$newLength -= $length;
		$png->{'IDATEndPos'} += $newLength;
		$png->{'size'} += $newLength;
		return 1;
	}

	$offset = $png->{$targetOffset};
	if($offset)
	{
		$length = $png->{$targetLength} + 12;
	}
	else
	{
		$offset = $png->{'newPLTEOffset'} if($target eq 'PLTE');
		if(!$offset)
		{
			$offset = $png->{'IDATBetaOffset'} - 8;
			return 0 if($offset < 0);
		}
		$png->{$targetOffset} = $offset;
		$length = 0;
	}

	if($newLength >= 0)
	{
		substr($$pngData, $offset, $length)
			= pack('N', $newLength).$target.$$newData.pack('N', &OutChunk(\$target, $newData, 1));
		$png->{$targetLength} = $newLength;
		$newLength += 12;
	}
	else
	{
		substr($$pngData, $offset, $length) = '';
		$png->{$targetOffset} = 0;
		$png->{$targetLength} = $newLength = 0;
	}
	$newLength -= $length;

	foreach ('PLTEOffset', 'tRNSOffset', 'bKGDOffset', 'IDATBetaOffset', 'IDATEndPos', 'size')
	{
		$png->{$_} += $newLength
			if($_ ne $targetOffset && $png->{$_} >= $offset);
	}
	$png->{'newPLTEOffset'} = $png->{'PLTEOffset'} if($png->{'PLTEOffset'});
	return 1;
}


# x^PNGB
sub BetaPNG
{
	my($pngData, $flags, $verbose) = @_;
	my($curPos, $length, $chunkName, $y, $count);
	my($bitDepth, $colourType, $bytesPerPixel);
	my(%png);
	my($width, $height, $widthBytes);
	my($bWant2DeltRNS, $bWant2MakeAlpha, $bWant2DelbKGD) = (0, 0, 0);
	my($bCacheFound) = 0;

	$pngren::errorMessage = '';

	# ȉ2swarningsɓ{ꂽŔÔ߁B
	$flags   = 0 if(!$flags);
	$verbose = 0 if(!$verbose);

#	%png = map({$_ => 0} (
#		'data', 'size', 'PLTEOffset', 'PLTELength', 'newPLTEOffset',
#		'tRNSOffset', 'tRNSLength', 'bKGDOffset', 'bKGDLength',
#		'IDATBetaOffset', 'IDATBetaLength', 'IDATEndPos'));

	%png = map({$_ => 0} qw| data size IDATBetaOffset IDATBetaLength IDATEndPos
		PLTEOffset PLTELength newPLTEOffset
		tRNSOffset tRNSLength bKGDOffset bKGDLength |);

	$png{'data'} = $pngData;

	if(substr($$pngData, 0, 8) ne "\x89PNG\x0d\x0a\x1a\x0a")
	{
		$pngren::errorMessage = 'PNG̃wb_ł͂ȂB';
		return 100;
	}
	if(substr($$pngData, 8, 8) ne "\0\0\0\x0dIHDR")
	{
		$pngren::errorMessage = 'ŏ̃`NIHDRɔ񂸁B';
		return 101;
	}
	if(substr($$pngData, 0x1a, 2) ne "\0\0")
	{
		$pngren::errorMessage = 'm̈k܂̓tB^B';
		return 102;
	}

	($width, $height, $bitDepth, $colourType)
		= unpack('N2C2', substr($$pngData, 0x10, 10));

	if(!&CheckValidity($bitDepth, $colourType))
	{
		$pngren::errorMessage = 'm̐Fʂ܂̓rbg[xB';
		return 105;
	}

	if(substr($$pngData, 0x1c, 1) ne "\0")
	{
		$pngren::errorMessage = 'C^[[XPNGB';
		return 200;
	}
	if($colourType != 3)
	{
		if($bitDepth < 8 && !($flags & $pngren::INC_BD8))
		{
			$pngren::errorMessage = "rbg[xG[ ($bitDepth)B";
			return 201;
		}
	}
	else
	{
		if(!($flags & $pngren::CONV_P2C))
		{
			$pngren::errorMessage = 'pbgJ[摜B';
			return 202;
		}
	}

	# sNZ̃oCgB
	if($colourType == 4)
	{
		$bytesPerPixel = $bitDepth >> 2;	# BD / 8 * 2 = BD / 4;
	}
	elsif($colourType == 6)
	{
		$bytesPerPixel = $bitDepth >> 1;	# BD / 8 * 4 = BD / 2;
	}
	elsif($colourType == 0 || $colourType == 3)
	{
		$bytesPerPixel = $bitDepth >> 3;	# BD / 8;
		# ̓rbg[x8̂Ƃ̂ŁA0ɂȂ邱ƂB
	}
	elsif($colourType == 2)
	{
		$bytesPerPixel = ($bitDepth >> 3) * 3;	# BD / 8 * 3;
	}

	# C̃oCgitB^jB
	if($bytesPerPixel > 0)
	{
		$widthBytes = $width * $bytesPerPixel;
	}
	else	# ColourType == 0 or 3, BitDepth < 8.
	{
		my($pixelsPerByte) = 8 / $bitDepth;
		$widthBytes = int($width / $pixelsPerByte) + ($width % $pixelsPerByte ? 1 : 0);
	}

	if(!$widthBytes)
	{
		$pngren::errorMessage = '0PNGB';
		return 110;
	}

	print "\n\tWidth = $width, Height = $height, BitDepth = $bitDepth, ColourType = $colourType, BytesPerPixel = $bytesPerPixel\n" if($verbose);

	if(substr($$pngData, -12) ne "\0\0\0\0IEND\xae\x42\x60\x82")
	{
		$pngren::errorMessage = 'ŏ̃`NIENDɔ񂸁B';
		return 107;
	}

	# PNG̊TvIBȉIDAT܂Ƃ߂ɂB

	$png{'size'} = length($$pngData);
	$curPos = 0x21;	# IHDŘB
	while(1)
	{
		if($curPos >= $png{'size'})
		{
			if(!$png{'IDATBetaOffset'})
			{
				$pngren::errorMessage = 'IDATIENDȂ܂܃Xg[̏I[܂ŗB';
				return 103;
			}
			$pngren::errorMessage = 't@CrŐ؂ĂB';
			return 109;
		}

		$length    = unpack('N', substr($$pngData, $curPos, 4));
		$chunkName = substr($$pngData, $curPos + 4, 4);

		print "\t$chunkName ($length bytes)\n" if($verbose);

		if($chunkName eq 'IDAT')
		{
			if($png{'IDATBetaOffset'})
			{
				if($png{'IDATBetaLength'} + $length < $png{'IDATBetaLength'})
				{
					$pngren::errorMessage = 'IDATĂ܂Ƃ߂ꂸB';
					return 203;	# ȎԂɂȂƂɂ̃vZXłB
				}
				$png{'IDATBetaLength'} += $length;
				substr($$pngData, $curPos - 4, 12) = '';
				$length -= 12;
				$png{'size'} -= 12;
			}
			else
			{
				$png{'IDATBetaOffset'} = $curPos + 8;
				$png{'IDATBetaLength'} = $length;
				$png{'newPLTEOffset'}  = $curPos if(!$png{'newPLTEOffset'});
			}
		}
		else
		{
			if($chunkName eq $pngren::cacheChunk)
			{
				$length += 12;
				substr($$pngData, $curPos, $length) = '';
				$png{'size'} -= $length;
				$length = -12;
				$bCacheFound = -2;
			}
			else
			{
				last if($png{'IDATBetaOffset'});
				# ȉAIDATOB
				if($chunkName eq 'IEND')
				{
					$pngren::errorMessage = 'IDATȂ܂IENDꂽB';
					return 104;
				}

				$png{'newPLTEOffset'} = $curPos
					if(!$png{'newPLTEOffset'}
						&& ($chunkName eq 'PLTE' || $chunkName eq 'bKGD'
							|| $chunkName eq 'tRNS' || $chunkName eq 'hIST'));

				if($chunkName eq 'PLTE' || $chunkName eq 'tRNS' || $chunkName eq 'bKGD'
					|| (!($flags & $pngren::ONLY6) && $chunkName ne 'hIST'))
				{
					$png{$chunkName.'Offset'} = $curPos;
					$png{$chunkName.'Length'} = $length;
				}
				else
				{
					$length += 12;
					substr($$pngData, $curPos, $length) = '';
					$png{'size'} -= $length;
					$length = -12;
				}
			}
		}
		$curPos += $length + 12;
	}

	# zlib̑B
	$curPos = $png{'IDATBetaOffset'};
	$png{'IDATEndPos'} = $curPos + $png{'IDATBetaLength'};

	if($verbose)
	{
		print "\tAll IDATs concatenated.\n";
		printf("\t -> IDAT data field [%08X-%08X (%d bytes)] "
			, $png{'IDATBetaOffset'}, $png{'IDATEndPos'} - 1, $png{'IDATBetaLength'});
		printf("/ End of all data [%08X]\n", $png{'size'} - 1);
	}

	if(!($flags & $pngren::IDAT_ZLIB))
	{		# "$png{'IDATBetaLength'} > 摜̈ĩoCg * " Ȃ
			# kȂ낤ǁAƂƂő厖B

		my($BFINAL, $BTYPE, $LEN, $NLEN);
		my($CMF, $FLG) = unpack('C2', substr($$pngData, $curPos, 2));

		if($verbose)
		{
			printf("\tScan starts at  [%08X]\n", $curPos);
			printf("\t\tCMF (%X), FLG (%X)\n", $CMF, $FLG);
		}

		if((($CMF << 8) | $FLG) % 31)
		{
			$pngren::errorMessage = sprintf("CMF * 256 + FLG31̔{ɔ (CMF %02X/FLG %02X)B", $CMF, $FLG);
			return 300;
		}
		if(($CMF & 15) != 8)
		{
			$pngren::errorMessage = 'Deflatekɔ񂸁B';
			return 301;
		}
		if($FLG & 0x20)
		{
			$pngren::errorMessage = 'OugĂB';
			return 302;
		}

		substr($$pngData, $curPos, 2) = '';
		$png{'IDATBetaLength'} -= 2;
		$png{'IDATEndPos'} -= 2;
		$png{'size'} -= 2;

		while(1)
		{
			if($curPos >= $png{'IDATEndPos'})
			{
				$pngren::errorMessage = 'BFINAL̂ȂsȏIB';
				return 303;
			}

			($BFINAL, $LEN, $NLEN) = unpack('Cv2', substr($$pngData, $curPos, 5));

			printf("\t\tBFINAL/BTYPE (%02X), LEN/NLEN (%04X/%04X)\n"
				, $BFINAL, $LEN, $NLEN) if($verbose);

			$BTYPE   = ($BFINAL >> 1) & 3;
			$BFINAL &= 1;

			if($BTYPE)
			{
				$pngren::errorMessage = 'kł͂ȂubNꂽB';
				return 400;
			}
			if($LEN + $NLEN != 0xffff)
			{
				$pngren::errorMessage = sprintf("LEN+NLEN0xFFFFɔ (%04X/%04X)B", $LEN, $NLEN);
				return 304;
			}

			substr($$pngData, $curPos, 5) = '';
			$png{'IDATBetaLength'} -= 5;
			$png{'IDATEndPos'} -= 5;
			$png{'size'} -= 5;

			last if($BFINAL);

			$curPos += $LEN;
		}
		substr($$pngData, $curPos, 4) = '';	# CRC(s1/s2)̍폜B
		$png{'IDATBetaLength'} -= 4;
		$png{'IDATEndPos'} -= 4;
		$png{'size'} -= 4;

		printf("\tScan ended at   [%08X]\n", $curPos) if($verbose);
	}
	else
	{
		my($newIDAT) = '';

		if(!$pngren::USEMYZLIB)
		{
			eval { require Compress::Zlib; };	# use Compress::Zlib;  $@ ŏEB
			if(!$@)
			{
				$newIDAT = &Compress::Zlib::uncompress(substr($$pngData, $curPos, $png{'IDATBetaLength'}));
				if(!defined($newIDAT))
				{
					$pngren::errorMessage = 'Zlibf[^̐LɎs (Compress::Zlib)B';
					return 305;
				}
				print "\tInflated by Compress::Zlib.\n" if($verbose);
			}
			else
			{
				$pngren::USEMYZLIB = 1;
			}
		}
		if($newIDAT eq '')	# fgotogقǂȂB
		{
			if(!&pryzlib::uncompress(\$newIDAT, \substr($$pngData, $curPos, $png{'IDATBetaLength'})))
			{
				$pngren::errorMessage = 'Zlibf[^̐LɎs (pryzlib.pl)B'."\n".$pryzlib::errorMessage;
				return 306;
			}
			print "\tInflated by PryZlib.\n" if($verbose);
		}
		return 900 if(!&Sashikae(\%png, 'IDATBeta', \$newIDAT));
	}

	if($verbose)
	{
		printf("\t -> IDAT data field [%08X-%08X (%d bytes)] "
			, $png{'IDATBetaOffset'}, $png{'IDATEndPos'} - 1, $png{'IDATBetaLength'});
		printf("/ End of all data [%08X]\n", $png{'size'} - 1);
	}

	# tB^B
	$curPos = $png{'IDATBetaOffset'};
	if(!($flags & $pngren::IDAT_FILTER))
	{
		for($y = 0; $y < $height; $y++)
		{
			printf("\t  Row #%03d (FilterType %d) starts at [%08X]\n"
				, $y, unpack('C', substr($$pngData, $curPos, 1)), $curPos)
				if($verbose >= 2);
			if(substr($$pngData, $curPos, 1) ne "\0")
			{
				$pngren::errorMessage = 'kptB^gĂB';
				return 204;
			}
			substr($$pngData, $curPos, 1) = '';
			$curPos += $widthBytes;
		}
	}
	else
	{
		my($newIDAT) = '';
		my(@mae, @ima, $lineOffset, $filterNumber, $filterFunc);

		@ima = (0) x $widthBytes;
		$y   = $count = 0;
		foreach(unpack('C*', substr($$pngData, $png{'IDATBetaOffset'}, $png{'IDATBetaLength'})))
		{
			if(!$count)
			{
				$filterNumber = $_;
				printf("\t  Row #%03d (FilterType %d) starts at [%08X]\n"
					, $y, $filterNumber, $curPos)
					if($verbose >= 2);

				if($filterNumber >= 5)
				{
					$pngren::errorMessage = 'm̈kptB^B';
					return 106;
				}

				$filterFunc = (sub{ return $_[0]; }, \&FilterSub, \&FilterUp
					, \&FilterAverage, \&FilterPaeth)[$filterNumber];

				@mae = @ima;
				@ima = ();
				$count = $widthBytes;
				$lineOffset = 0;
				$y++;
			}
			elsif($count)
			{
				push(@ima, &$filterFunc($_, $lineOffset++, $bytesPerPixel, \@ima, \@mae) & 0xff);
				$count--;
			}
			$newIDAT .= join('', pack('C*', @ima)) if(!$count);	# C̏IB
			$curPos++;
		}
		substr($$pngData, $png{'IDATBetaOffset'}, $png{'IDATBetaLength'}) = $newIDAT;
	}
	$png{'IDATBetaLength'} -= $height;
	$png{'IDATEndPos'} -= $height;
	$png{'size'} -= $height;

	if($verbose)
	{
		print "\tFilter(s) processed.\n";
		printf("\t -> IDAT data field [%08X-%08X (%d bytes)] "
			, $png{'IDATBetaOffset'}, $png{'IDATEndPos'} - 1, $png{'IDATBetaLength'});
		printf("/ End of all data [%08X]\n", $png{'size'} - 1);
	}


	# IDAT̃x^f[^Bȉ͉摜f[^̑B
#	&MakeCRCTable;


	# rbg[xグB
	if(
	(($flags & $pngren::CONV_P2C) && $colourType == 3)
	||
	(($flags & $pngren::CONV_G2C) && ($colourType == 0 || $colourType == 4))
	||
	(($flags & $pngren::INC_BD8) && $colourType == 0 && $bitDepth < 8)
	)
	{
		print "\tChanges ColourType/BitDepth/BytesPerPixel [$colourType/$bitDepth/$bytesPerPixel] -> " if($verbose);

		if($colourType == 3)
		{		# ccǂ̏ĂB
			my($newIDAT, $tempIDAT) = ('', '');
			my($pIDAT) = \substr($$pngData, $png{'IDATBetaOffset'}, $png{'IDATBetaLength'});
			my($pPLTE) = \substr($$pngData, $png{'PLTEOffset'} + 8, 768);
			# {^Ȃ $png{'PLTELength'} ̒ǂ₯ǁA
			# pbg͈̔͂zlLVȃf[^ȂƂ
			# ̂ŁASċKi̍ŒlnƂB

			if(!$png{'PLTEOffset'})
			{
				$pngren::errorMessage = 'PLTE`NȂB';
				return 108;
			}

			if($bitDepth < 8)
			{
				&Convert8bits(\$tempIDAT, $bitDepth, $width, $pIDAT);
				$pIDAT = \$tempIDAT;
			}

			if(!$png{'tRNSOffset'} || ($flags & $pngren::DELALPHA))
			{		# ߂Ȃ24rbgJ[B
				foreach (unpack('C*', $$pIDAT))
				{
					$newIDAT .= substr($$pPLTE, $_ * 3, 3);
				}
				$colourType = 2;
				$bytesPerPixel = 3;
			}
			else	# ߂24rbgJ[B
			{
				my($temptRNS) = "\xff" x 256;

				substr($temptRNS, 0, $png{'tRNSLength'})
					= substr($$pngData, $png{'tRNSOffset'} + 8, $png{'tRNSLength'});

				foreach (unpack('C*', $$pIDAT))
				{
					$newIDAT .= substr($$pPLTE, $_ * 3, 3);
					$newIDAT .= substr($temptRNS, $_, 1);
				}
				$colourType = 6;
				$bytesPerPixel = 4;
				$bWant2DeltRNS = 1;
			}
			return 901 if(!&Sashikae(\%png, 'IDATBeta', \$newIDAT));
			$bitDepth = 8;

			# bKGD̍ւB
			$curPos = $png{'bKGDOffset'};
			if($curPos)
			{
				my($newbKGD);

				$curPos  = unpack('C', substr($$pngData, $curPos + 8, 1)) * 3;
				$newbKGD = "\0".substr($$pPLTE, $curPos++, 1)."\0".substr($$pPLTE, $curPos++, 1)."\0".substr($$pPLTE, $curPos, 1);
				return 902 if(!&Sashikae(\%png, 'bKGD', \$newbKGD));
			}
			return 903 if(!&Sashikae(\%png, 'PLTE', \'', -1));
			# {^͎ۂɌꂽFPLTE`Nč\zāA
			# LbV̒ɓƂ̂xXgBtJ[łPLTE͂ėǂB
		}
		else	# ColourType == 0 or 4.
		{
			if($bitDepth < 8)	# G2CłǂKvȏ₵pB
			{
				my($numOfColours, $pixelsPerByte, $grey, $i, $j, $newChunk);
				my($newIDAT, $tempIDAT) = ('', '');
				my(@palette) = ();

				$numOfColours  = 1 << $bitDepth;
				$pixelsPerByte = 8 /  $bitDepth;
				for($i = 0; $i < $numOfColours; $i++)	# ǂőł16B
				{
					$grey = 0;
					for($j = 0; $j < $pixelsPerByte; $j++)
					{
						$grey <<= $bitDepth;
						$grey  |= $i;
					}
					push(@palette, pack('C', $grey));
				}

				&Convert8bits(\$tempIDAT, $bitDepth, $width, \substr($$pngData, $png{'IDATBetaOffset'}, $png{'IDATBetaLength'}));
				foreach (unpack('C*', $tempIDAT))
				{
					$newIDAT .= $palette[$_];
				}
				return 904 if(!&Sashikae(\%png, 'IDATBeta', \$newIDAT));
				$bitDepth = 8;
				$bytesPerPixel = 1;

				$curPos = $png{'tRNSOffset'};
				if($curPos && !($flags & $pngren::DELALPHA))
				{
					$newChunk = "\0".$palette[unpack('n', substr($$pngData, $curPos + 8, 2)) & ($numOfColours - 1)];	# &ȉ͂܂ȂB

					return 905 if(!&Sashikae(\%png, 'tRNS', \$newChunk));
# ƂPNGȂA
# substr($$pngData, $png{'tRNSOffset'} +  8, 2) = $newChunk;
# substr($$pngData, $png{'tRNSOffset'} + 10, 4) = pack('N', &OutChunk(\'tRNS', \$newChunk, 1));
# ōςޘb₯ǁA厖邱ƂɂB
				}

				$curPos = $png{'bKGDOffset'};
				if($curPos)
				{
					$newChunk = "\0".$palette[unpack('n', substr($$pngData, $curPos + 8, 2)) & ($numOfColours - 1)];

					return 906 if(!&Sashikae(\%png, 'bKGD', \$newChunk));
					# ƂPNGȂijB
				}
			}
			# 8bits邱Ƃۏ؁B

			if($flags & $pngren::CONV_G2C)
			{
				my($newIDAT, $tempIDAT) = ('', '');
				my($step) = $bitDepth >> 3;
				my($newChunk);

				$curPos = $png{'IDATBetaOffset'};
				if($colourType == 0)
				{
					for(; $curPos < $png{'IDATEndPos'}; $curPos += $step)
					{
						$newIDAT .= substr($$pngData, $curPos, $step) x 3;
					}

					# tRNS̍ւB
					$curPos = $png{'tRNSOffset'};
					if($curPos)
					{
						$newChunk = substr($$pngData, $curPos + 8, 2) x 3;
						return 907 if(!&Sashikae(\%png, 'tRNS', \$newChunk));
						$bWant2MakeAlpha = 1;
					}
					$bytesPerPixel *= 3;
				}
				else	# ColourType == 4.
				{
					for(; $curPos < $png{'IDATEndPos'}; $curPos += $step)
					{
						$newIDAT .= substr($$pngData, $curPos, $step) x 3;
						$curPos  += $step;
						$newIDAT .= substr($$pngData, $curPos, $step);
					}
					$bytesPerPixel <<= 1;
				}
				return 908 if(!&Sashikae(\%png, 'IDATBeta', \$newIDAT));
				$colourType |= 2;

				# bKGD̍ւB
				$curPos = $png{'bKGDOffset'};
				if($curPos)
				{
					$newChunk = substr($$pngData, $curPos + 8, 2) x 3;
					return 909 if(!&Sashikae(\%png, 'bKGD', \$newChunk));
				}
			}
		}
		print "[$colourType/$bitDepth/$bytesPerPixel] @ Increasing BitDepth.\n" if($verbose);
	}

	# `l̍쐬B
	if($bWant2MakeAlpha
	||
	(($flags & $pngren::MAKEALPHA)
		&& ($colourType == 0 || $colourType == 2)
		&& (!($bitDepth & 7) && ($bitDepth >> 3))
	))
	{
		my($bytes) = $bitDepth >> 3;
		my($futooka) = "\xff" x $bytes;
		my($newIDAT) = '';

		print "\tChanges ColourType/BitDepth/BytesPerPixel [$colourType/$bitDepth/$bytesPerPixel] -> " if($verbose);

		$curPos = $png{'tRNSOffset'};
		if(!$curPos)
		{
			$curPos = $png{'IDATBetaOffset'};
			for(; $curPos < $png{'IDATEndPos'}; $curPos += $bytesPerPixel)
			{
				$newIDAT .= substr($$pngData, $curPos, $bytesPerPixel);
				$newIDAT .= $futooka;
			}
		}
		else
		{
			my($tookaRGB, $RGB);
			my($tooka) = "\x00" x $bytes;

			$curPos  += 10 - $bytes;	# =8+2-bytes.
			$tookaRGB = substr($$pngData, $curPos, $bytes);
			if($colourType & 2)
			{
				$curPos   += 2;
				$tookaRGB .= substr($$pngData, $curPos, $bytes);
				$curPos   += 2;
				$tookaRGB .= substr($$pngData, $curPos, $bytes);
			}
			return 920 if($bytesPerPixel != length($tookaRGB));

			for($curPos = $png{'IDATBetaOffset'}; $curPos < $png{'IDATEndPos'}; $curPos += $bytesPerPixel)
			{
				$RGB = substr($$pngData, $curPos, $bytesPerPixel);
				$newIDAT .= $RGB;
				$newIDAT .= $RGB ne $tookaRGB ? $futooka : $tooka;
			}
		}
		return 910 if(!&Sashikae(\%png, 'IDATBeta', \$newIDAT));

		$bytesPerPixel += $bitDepth >> 3;
		$colourType    |= 4;
		$bWant2DeltRNS  = 1;

		print "[$colourType/$bitDepth/$bytesPerPixel] @ Making Alpha.\n" if($verbose);
	}
	# todo, ƉArɂׂB
	# `l̍폜B
	if(
	($flags & $pngren::DELALPHA)
	&&
	($colourType == 4 || $colourType == 6)
	&&
	(!($bitDepth & 7) && ($bitDepth >> 3))	# ܂ȂB
	)
	{
		my($alphaSize) = $bitDepth >> 3;
		my($motonoOwari);

		print "\tChanges ColourType/BitDepth/BytesPerPixel [$colourType/$bitDepth/$bytesPerPixel] -> " if($verbose);

		$motonoOwari = $png{'IDATEndPos'};
		$bytesPerPixel -= $alphaSize;
		for($curPos = $png{'IDATBetaOffset'}; $curPos < $png{'IDATEndPos'}; $curPos += $bytesPerPixel)
		{
			substr($$pngData, $curPos + $bytesPerPixel, $alphaSize) = '';
			$png{'IDATEndPos'} -= $alphaSize;
		}
		$motonoOwari -= $png{'IDATEndPos'};
		$png{'IDATBetaLength'} -= $motonoOwari;
		$png{'size'} -= $motonoOwari;
		$colourType &= ~4;

		print "[$colourType/$bitDepth/$bytesPerPixel] @ Deleting Alpha.\n" if($verbose);
	}


	# Web Safe ColoursɌFB
	if(
	($flags & $pngren::CONV_WSCs)
	&&
	($colourType == 2 || $colourType == 6)
	&&
	(!($bitDepth & 7) && ($bitDepth >> 3))
	)
	{
		my($newIDAT, $newPLTE) = ('', '');
		my($r, $g, $b, $a, $pattern, $border, $kiriage, $iroban, $alphaShift);

		print "\tChanges ColourType/BitDepth/BytesPerPixel [$colourType/$bitDepth/$bytesPerPixel] -> " if($verbose);

		# Web Safe Coloursp̃pbgB
		for($r = 0; $r < 0x100; $r += 0x33)
		{
			for($g = 0; $g < 0x100; $g += 0x33)
			{
				for($b = 0; $b < 0x100; $b += 0x33)
				{
					$newPLTE .= pack('C3', $r, $g, $b);
				}
			}
		}
		return 911 if(!&Sashikae(\%png, 'PLTE', \$newPLTE));

		# 摜f[^̕ϊtRNS̐B
		if($bitDepth == 8)
		{
			$pattern = 'C*';
			$border  = 0x33;
			$alphaShift = 0;
		}
		else	# BitDepth == 16.
		{
			$pattern = 'n*';
			$border  = 0x3333;
			$alphaShift = 8;
		}
		$kiriage = $border >> 1;

		$curPos = $png{'IDATBetaOffset'};
		if(!($colourType & 4))	# ȂB
		{
			for(; $curPos < $png{'IDATEndPos'}; $curPos += $bytesPerPixel)
			{
				($r, $g, $b) = unpack($pattern, substr($$pngData, $curPos, $bytesPerPixel));
				$r = int(($r + $kiriage) / $border);
				$g = int(($g + $kiriage) / $border);
				$b = int(($b + $kiriage) / $border);
				$newIDAT .= pack('C', ($r * 36 + $g * 6 + $b) & 0xff);
			}		# &ȉ͂܂ȂB
		}
		else	# B
		{
			my($newtRNSLength) = 216;
			my($newtRNS) = "\xff" x $newtRNSLength;

			for(; $curPos < $png{'IDATEndPos'}; $curPos += $bytesPerPixel)
			{
				($r, $g, $b, $a) = unpack($pattern, substr($$pngData, $curPos, $bytesPerPixel));
				$r = int(($r + $kiriage) / $border);
				$g = int(($g + $kiriage) / $border);
				$b = int(($b + $kiriage) / $border);
				$iroban = ($r * 36 + $g * 6 + $b) & 0xff;
				$newIDAT .= pack('C', $iroban);
				substr($newtRNS, $iroban, 1) = pack($pattern, ($a >> $alphaShift) & 0xff);
			}

			# tRNS}B
			if(!($flags & $pngren::tRNS_DROP))
			{
				while($newtRNSLength--)
				{
					last if(substr($newtRNS, $newtRNSLength , 1) ne "\xff");
				}
				$newtRNSLength++;

				if($newtRNSLength)
				{
					$newtRNS = substr($newtRNS, 0, $newtRNSLength);
					return 912 if(!&Sashikae(\%png, 'tRNS', \$newtRNS));
				}
				$bWant2DeltRNS = 0;
			}
		}
		# IDAT̍ւB
		return 913 if(!&Sashikae(\%png, 'IDATBeta', \$newIDAT));

		$curPos = $png{'bKGDOffset'};
		if($curPos)
		{		# ܂IEɃoȎ݂Ƃ́B
			($r, $g, $b) = unpack('n*', substr($$pngData, $curPos + 8, 6));

			$r = int(($r + $kiriage) / $border);
			$g = int(($g + $kiriage) / $border);
			$b = int(($b + $kiriage) / $border);
			$newPLTE = pack('C', ($r * 36 + $g * 6 + $b) & 0xff);
			return 922 if(!&Sashikae(\%png, 'bKGD', \$newPLTE));
		}

		$bitDepth = 8;
		$colourType = 3;
		$bytesPerPixel = 1;

		print "[$colourType/$bitDepth/$bytesPerPixel] @ Converting to Web-Safe Colours.\n" if($verbose);
	}
	# 8bitB
	elsif(
		($flags & $pngren::DEC_BD8)
		&&
		$colourType != 3	# ܂ȂB
		&&
		(!($bitDepth & 15) && ($bitDepth >> 4))
	)
	{
		my($bytes) = $bitDepth >> 3;
		my($newIDAT) = '';
		my($newChunk);

		print "\tChanges ColourType/BitDepth/BytesPerPixel [$colourType/$bitDepth/$bytesPerPixel] -> " if($verbose);

		for($curPos = $png{'IDATBetaOffset'}; $curPos < $png{'IDATEndPos'}; $curPos += $bytes)
		{
			$newIDAT .= substr($$pngData, $curPos, 1);
		}
		return 914 if(!&Sashikae(\%png, 'IDATBeta', \$newIDAT));
		$bitDepth = 8;
		$bytesPerPixel /= $bytes;

		$curPos = $png{'tRNSOffset'};
		if($curPos)
		{
			$newChunk  = "\0".substr($$pngData, $curPos + 8, 1);
			$newChunk .= "\0".substr($$pngData, $curPos + 10, 1)."\0".substr($$pngData, $curPos + 12, 1)
				if($colourType & 2);
			return 915 if(!&Sashikae(\%png, 'tRNS', \$newChunk));
		}

		$curPos = $png{'bKGDOffset'};
		if($curPos)
		{
			$newChunk  = "\0".substr($$pngData, $curPos + 8, 1);
			$newChunk .= "\0".substr($$pngData, $curPos + 10, 1)."\0".substr($$pngData, $curPos + 12, 1)
				if($colourType & 2);
			return 916 if(!&Sashikae(\%png, 'bKGD', \$newChunk));
		}

		print "[$colourType/$bitDepth/$bytesPerPixel] @ Decreasing BitDepth to 8.\n" if($verbose);
	}
	# 16bitB
	elsif(($flags & $pngren::INC_BD16) && $colourType != 3 && $bitDepth == 8)
	{
		my($newIDAT) = '';

		print "\tChanges ColourType/BitDepth/BytesPerPixel [$colourType/$bitDepth/$bytesPerPixel] -> " if($verbose);

		for($curPos = $png{'IDATBetaOffset'}; $curPos < $png{'IDATEndPos'}; $curPos++)
		{		# foreach(split(//, `Ƃǂ̂ȂB
			$newIDAT .= substr($$pngData, $curPos, 1) x 2;
		}
		return 917 if(!&Sashikae(\%png, 'IDATBeta', \$newIDAT));
		$bitDepth = 16;
		$bytesPerPixel <<= 1;

		print "[$colourType/$bitDepth/$bytesPerPixel] @ Converting BitDepth to 16.\n" if($verbose);
	}

	# tRNS`N؂̂āB
	if($png{'tRNSOffset'}
		&& (($flags & $pngren::tRNS_DROP) || $bWant2DeltRNS))
	{
		return 918 if(!&Sashikae(\%png, 'tRNS', \'', -1));
	}

	# bKGD`N؂̂āB
	if($png{'bKGDOffset'}
		&& (($flags & $pngren::bKGD_DROP) || $bWant2DelbKGD))
	{
		return 919 if(!&Sashikae(\%png, 'bKGD', \'', -1));
	}

	{
		my($s1, $s2, $crc, $initCrc, $header);
		my($newIDAT) = '';

		$widthBytes = $width * $bytesPerPixel;
		if($widthBytes > 65535)
		{
			$pngren::errorMessage = '65535oCgzPNGB';
			return 205;
			# ςޘbȂ₯ǁÃXNvgł܂łƂȂB
		}
		$crc = ~$widthBytes;	# ]pB
		$header  = "IDAT\0".pack('v2', $widthBytes, $crc);
		$initCrc = 0xD7C78217;	# "IDAT\0".
		foreach($widthBytes, $widthBytes >> 8, $crc, $crc >> 8)
		{
			$initCrc = $pngren::crcTable[($initCrc ^ $_) & 0xff] ^ ($initCrc >> 8);
		}

		$count = 0;
		$curPos = $png{'IDATBetaOffset'};
		foreach(unpack('C*', substr($$pngData, $curPos, $png{'IDATBetaLength'})))
		{
			if(!$count)
			{
				$s1 = $s2 = 0;
				$count = $widthBytes;
				$crc = $initCrc;
			}
			$s1 += $_;
			$s1 -= 65521 if($s1 > 65520);
			$s2 += $s1;
			$s2 -= 65521 if($s2 > 65520);
			$crc = $pngren::crcTable[($crc ^ $_) & 0xff] ^ ($crc >> 8);
			$count--;
			if(!$count)
			{
				$newIDAT .= pack('N', $widthBytes + 5).$header.substr($$pngData, $curPos, $widthBytes).pack('Nn2', ~$crc, $s1, $s2);
				$curPos += $widthBytes;
			}
		}
		return 921 if(!&Sashikae(\%png, 'IDATBeta', \$newIDAT));
	}

	# x^f[^ւB
	substr($$pngData, $png{'IDATEndPos'}) = pack('N2C4N'
		, $png{'IDATBetaOffset'}
		, $png{'IDATBetaLength'}	# LbV쐬֐ɓnKvB
		, $bitDepth, $colourType, $bytesPerPixel, 0
		, 0);

	print "\tImage data ends up with [ColourType = $colourType, BitDepth = $bitDepth, BytesPerPixel = $bytesPerPixel]\n"
		if($verbose);

	return $bCacheFound;	# OK(0)  ReCached(-2).
}


# LbVB
sub _CachePNG
{
	my($pngFile, $flags, $modoriCI, $verbose) = @_;
	my($pngSize, $header, $pngData, $result, $chunkData, $IDATBetaOffset, $IDATBetaLength, $datachoo, $colourInfo, $chunkName, $length, $curPos, $hozhoLength);

	$pngren::errorMessage = '';

	$flags   = 0 if(!$flags);
	$verbose = 0 if(!$verbose);

	if(!$pngFile || !open(IN, $$pngFile))
	{
		$pngren::errorMessage = qq|"$$pngFile" ȂB|;
		return 1000;
	}
	$pngSize = -s $$pngFile;
	binmode(IN);
	seek(IN, 0, 0);
	read(IN, $header, $pngren::HEADER_SIZE);
	$$modoriCI = substr($header, 0x10, 13) if(ref($modoriCI));
	if(!($flags & ($pngren::RECACHE | $pngren::PARSEONLY)))
	{
		$result = &CheckCache($header, $pngren::cacheChunk, $pngren::cacheVersion);
		if($result > 0)		# ɂB
		{
			read(IN, $pngData, $result);
			$$modoriCI .= substr($pngData, $pngren::FOOTER_BETAINFO, 4)
				if(ref($modoriCI));
			close(IN);
			return -1;
		}
		elsif($result == -1 && !($flags & $pngren::MODIFYCACHE))
		{		# @[WႢB
			close(IN);
			$pngren::errorMessage = 'dlႢ̃LbVɂB';
			return 1001;
		}
	}
	seek(IN, 0, 0);
	read(IN, $pngData, $pngSize);
	close(IN);
	$result = &BetaPNG(\$pngData, $flags, $verbose);

	# ꂾɁB
	$colourInfo = unpack('N', substr($pngData, $pngren::FOOTER_BETAINFO, 4));
	$$modoriCI .= pack('N', $colourInfo) if(ref($modoriCI));

	return $result if($result > 0);
	return -3 if($flags & $pngren::PARSEONLY);

#	&MakeCRCTable;

	if(!open(IN, $$pngFile))
	{
		$pngren::errorMessage = qq|"$$pngFile" ̓ǂݍ݂ɎsB|;
		return 1003;
	}
	if(!open(OUT, ">$$pngFile".'_cache'))
	{
		close(IN);
		$pngren::errorMessage = 'LbV݂̏Ɏs';
		rename("$$pngFile.backup", $$pngFile);
		return 1004;
	}

	binmode(IN);
	binmode(OUT);
	select(OUT);

	print substr($pngData, 0, 0x21);

	($IDATBetaOffset, $IDATBetaLength)
		= unpack('N*', substr($pngData, $pngren::FOOTER_BETA, 8));
	$hozhoLength = $IDATBetaOffset - 0x29;

	$chunkData  = $pngren::cacheVersion;
	$chunkData .= pack('N', $IDATBetaLength + 8);
	$chunkData .= substr($pngData, $IDATBetaOffset, $IDATBetaLength);
	$chunkData .= pack('N*', $colourInfo, $hozhoLength + 4);
	$chunkData .= substr($pngData, 0x21, $hozhoLength);
	$chunkData .= "\0\0\0\0";

	if($flags & $pngren::LOOSECRC)
	{
		print pack('N', length($chunkData));
		print $pngren::cacheChunk;
		print $chunkData;
		print "\0\0\0\0";
	}
	else
	{
		&OutChunk(\$pngren::cacheChunk, \$chunkData);
	}

	seek(IN, 0, 0);
	read(IN, $pngData, $pngSize);
	$curPos = 0x21;	# IHDŘB
	while($curPos < $pngSize)
	{
		$length    = unpack('N', substr($pngData, $curPos, 4));
		$chunkName = substr($pngData, $curPos + 4, 4);

		$length += 12;
		print OUT substr($pngData, $curPos, $length)
			if($chunkName ne $pngren::cacheChunk);
		$curPos += $length;
	}

	close(IN);
	close(OUT);
	select(STDOUT);

	# rŃvZX~߂Ẳ摜t@C悤ŌɕύXB
	if(!rename($$pngFile, $$pngFile.'_backup'))
	{
		$pngren::errorMessage = 'obNAbv̍쐬ɎsB';
		return 1002;
	}
	if(!rename($$pngFile.'_cache', $$pngFile))
	{
		$pngren::errorMessage = 'LbVt@C̖OύXɎsB';
		return 1005;
	}

	return $result;	# 0(OK)  -2(ReCached).
}


;#--------------------------------------------------------------------
##
##  PNGACu"pngren.pl"p⏕CuEzlibfR[h
##
##  ZlibfR[_ƂĂ̐
##    f[^oCgPʂł͂ȂrbgPʂŊǗĂ邽߁A32rb
##    gVXeł͋炭(2^32)/8=536870912oCg=512MB܂ł̃f[
##    ^舵܂B
##
##--------------------------------------------------------------------


#use strict;	# debug.
#use warnings;	# debug.


package pryzlib;


$pryzlib::debug = 0;


sub HuffmanTableTsukuru
{
	my($huffmanTable, $saitanBit, $saichooBit, $nagasaTable, $saidaiMozhi) = @_;
	my(@tsugi) = ();
	my($i, $bitchoo, $hantemMae, $hantenGo, @bitchooKosuu);

	# erbgƂɐ𐔂AłɍŒZEŒrbĝׂ̂ƂB
	$$saitanBit   = ~0;
	$$saichooBit  =  0;
	@bitchooKosuu = (0) x 32;
			# mɂ͉rbgv낤ccƂƂŒׂĂ݂B
			# HCLEN̎0-7(3bits).
			# ÓInt}e[u鎞dis5lit7-9.
			# Int}e[u鎞dislit-15?
	for($i = 0; $i < $saidaiMozhi; $i++)
	{
		$bitchoo = $nagasaTable->[$i] || 0;
		$bitchooKosuu[$bitchoo]++;
		$$saichooBit = $bitchoo if($$saichooBit < $bitchoo);
		$$saitanBit  = $bitchoo if($bitchoo && $$saitanBit > $bitchoo);
	}

	# NextCode߂B
	$tsugi[0] = $bitchooKosuu[0] = 0;
	for($i = 1; $i < 16; $i++)
	{
		$tsugi[$i] = ($tsugi[$i - 1] + $bitchooKosuu[$i - 1]) << 1;
	}

	# elɃR[hl߂B
	for($i = 0; $i < $saidaiMozhi; $i++)
	{
		$bitchoo = $nagasaTable->[$i];
		if($bitchoo)		# rbg0ȂlUB
		{
			# GfBA]B
			$hantemMae = $tsugi[$bitchoo]++;
			$hantenGo  = 0;
			while($bitchoo--)
			{
				$hantenGo  <<= 1;
				$hantenGo   |= $hantemMae & 1;
				$hantemMae >>= 1;
			}
#			$huffmanTable->[$i] = $hantenGo;
			$huffmanTable->{$hantenGo} = $i + 1;	# 0h~B
		}
	}
}


# HCLENe[uɃe[uǂݍށB
sub TableYomikomu
{
	my($table, $saitanBit, $saichooBit, $nagasaTable, $huffmanTable, $saidaiMozhi) = @_;
	my($ichi, $huff, $code, $atai, $nagasa, $eruBits, $masked, $bitchoo);
	my(@zhuu6kara8bits)   = (2, 3,  7);
	my(@zhuu6kara8tsuika) = (3, 3, 11);

	@$table = ("\0") x $saidaiMozhi;
	for($ichi = 0; $ichi < $saidaiMozhi;)
	{
		$code = unpack('V', substr($$pryzlib::data, $pryzlib::bitIchi >> 3, 4))
			>> ($pryzlib::bitIchi & 7);

		for($bitchoo = $saitanBit; $bitchoo <= $saichooBit; $bitchoo++)
		{
			$masked = $code & $pryzlib::masks[$bitchoo];
			$huff   = $huffmanTable->{$masked};
			if($huff && $nagasaTable->[$huff - 1] == $bitchoo)
			{
				$pryzlib::bitIchi += $bitchoo;
				$huff--;
				goto HuffCodeFound;
			}
		}
		return &HuffmanArahenError(0, $code);

		HuffCodeFound:

		if($huff < 16)
		{
			$table->[$ichi] = $huff;
			$ichi++;
			next;
		}
		if($huff > 18)
		{
			$pryzlib::errorMessage = "e[u쐬G[ ($huff)B";
			return 0;
		}
		# c16-18.

		$huff -= 16;
		$atai  = !$huff ? $table->[$ichi - 1] : 0;

		return &ShuutanError(0)
			if($pryzlib::bitIchi + $zhuu6kara8bits[$huff] > $pryzlib::sooBitSuu);

		$eruBits = $zhuu6kara8bits[$huff];

		$nagasa
			= unpack('V', substr($$pryzlib::data, $pryzlib::bitIchi >> 3, 4))
			>> ($pryzlib::bitIchi & 7) & $pryzlib::masks[$eruBits];
		$pryzlib::bitIchi += $eruBits;

		$nagasa += $zhuu6kara8tsuika[$huff];

		while($nagasa--)
		{
			$table->[$ichi++] = $atai;
		}
	}
	return 1;
}


# ÓInt}R[h\̍쐬B
sub SHuffmanTable
{
	my($litNagasaTable, $disNagasaTable) = @_;
	my($i) = 0;

	# prbge[uB
	@$disNagasaTable = (5) x 32;

	# e/prbge[uB
	for(; $i <= 0x8f; $i++)		# 0x00-0x8f
	{
		$litNagasaTable->[$i] = 8;
	}
	for(; $i <= 0xff; $i++)		# 0x90-0xff
	{
		$litNagasaTable->[$i] = 9;
	}
	for(; $i <= 0x117; $i++)	# 0x100-0x117
	{
		$litNagasaTable->[$i] = 7;
	}
	for(; $i <=0x11f; $i++)		# 0x118-0x11f
	{
		$litNagasaTable->[$i] = 8;
	}
}


# Int}R[h\̍쐬B
sub DHuffmanTable
{
	my($litNagasaTable, $disNagasaTable) = @_;
	my($HLIT, $HDIST, $HCLEN, $HCLENSaitanBit, $HCLENSaichooBit, $ichi, $huff);
	my(%HCLENHuffmanTable)   = ();		# c[p̃rbge[uB
	my(@HCLENNagasaTable) = (0) x 19;

	return &ShuutanError(0)
		if($pryzlib::bitIchi + 14 > $pryzlib::sooBitSuu);

	$HLIT = $HDIST = $HCLEN = unpack('V', substr($$pryzlib::data, $pryzlib::bitIchi >> 3, 4)) >> ($pryzlib::bitIchi & 7);

	$HLIT &= 31;
	$HLIT += 257;

	$HDIST >>= 5;
	$HDIST  &= 31;
	$HDIST++;

	$HCLEN >>= 10;
	$HCLEN  &= 15;
	$HCLEN  += 4;

	$pryzlib::bitIchi += 14;

	print "HLIT/$HLIT, HDIST/$HDIST, HCLEN/$HCLEN\n" if($pryzlib::debug >= 2);

	&ShuutanError(0)
		if($pryzlib::bitIchi + $HCLEN * 3 > $pryzlib::sooBitSuu);

	for($ichi = 0; $ichi < $HCLEN; $ichi++)
	{
		$HCLENNagasaTable[
			(16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15)[$ichi]
			]
			= (unpack('V', substr($$pryzlib::data, $pryzlib::bitIchi >> 3, 4))
			>> ($pryzlib::bitIchi & 7)) & 7;
		$pryzlib::bitIchi += 3;
	}

	&HuffmanTableTsukuru(\%HCLENHuffmanTable, \$HCLENSaitanBit, \$HCLENSaichooBit, \@HCLENNagasaTable, 19);

	@$litNagasaTable = ();
	return 0 if(!&TableYomikomu($litNagasaTable, $HCLENSaitanBit, $HCLENSaichooBit
		, \@HCLENNagasaTable, \%HCLENHuffmanTable, $HLIT));
	# epe[uB

	@$disNagasaTable = ();
	return 0 if(!&TableYomikomu($disNagasaTable, $HCLENSaitanBit, $HCLENSaichooBit
		, \@HCLENNagasaTable, \%HCLENHuffmanTable, $HDIST));
	# pe[uB

	return 1;
}


sub HuffmanArahenError
{
	$pryzlib::errorMessage = "Ynt}R[hȂirbgʒu $pryzlib::bitIchi [$_[1]]jB";
	return $_[0];
}


sub ShuutanError
{
	$pryzlib::errorMessage = "f[^I[܂ŗAIR[hꂸ ($pryzlib::bitIchi/$pryzlib::sooBitSuu)B";
	return $_[0];
}


# Zlibf[^Xg[̐LsBԂlBOOL.
# 1iԂlELσf[^jE2ikf[^jƂQƓnB
sub uncompress
{
	my($CMF, $FLG, $BTYPE, $BFINAL, $LEN, $NLEN);
	my($mozhi, $huff, $kyori, $shippo, $ex, $atai, $nagasa, $kakuchoo);
	my($litSaitanBit, $litSaichooBit, $disSaitanBit, $disSaichooBit, $masked, $bitchoo);
	my(@litNagasaTable, @disNagasaTable, %litHuffmanTable, %disHuffmanTable) = ();

	my($kaeriData) = $_[0];

	$pryzlib::data = $_[1];
	$pryzlib::errorMessage = '';
	$pryzlib::sooBitSuu = length($$pryzlib::data) << 3;

	$pryzlib::masks = ();
	for($mozhi = 0; $mozhi <= 32; $mozhi++)
	{		# mɂ͉rbg܂ŕKvȂ낤B
		$pryzlib::masks[$mozhi] = (1 << $mozhi) - 1;
	}

	# ŏ2oCg̏B
	($CMF, $FLG) = unpack('C2', substr($$pryzlib::data, 0, 2));

	if((($CMF << 8) | $FLG) % 31)
	{
		$pryzlib::errorMessage = sprintf("CMF * 256 + FLG31̔{ɔ (CMF %02X/FLG %02X)B", $CMF, $FLG);
		return 0;
	}
	if(($CMF & 15) != 8)
	{
		$pryzlib::errorMessage = 'Deflatekɔ񂸁B';
		return 0;
	}
	# CINFO͖B
	if($FLG & 0x20)
	{
		$pryzlib::errorMessage = 'OugĂB';
		return 0;
	}
	$pryzlib::bitIchi = 16;	# ŏB
	# CMF/FLGɂ͖ȂB

	while(1)
	{
		return &ShuutanError(0)
			if($pryzlib::bitIchi + 3 > $pryzlib::sooBitSuu);

		$BFINAL = (
			unpack('V', substr($$pryzlib::data, $pryzlib::bitIchi >> 3, 4))
			>> ($pryzlib::bitIchi & 7)
			) & 7;
		$BTYPE   = $BFINAL >> 1;
		$BFINAL &= 1;
		$pryzlib::bitIchi += 3;

		if($pryzlib::debug)	# debug.
		{	# debug.
			print "\n$pryzlib::bitIchi: ";	# debug.
			print (('܂܂', 'ItO')[$BFINAL]);	# debug.
			print (('kubN... ', 'ÓInt}ubN... ', 'Int}ubN... ', "G[i擪̃rbgʒuF$pryzlib::bitIchij\n")[$BTYPE]);	# debug.
		}	# debug.

		if(!$BTYPE)	# kB
		{
			$pryzlib::bitIchi  += 7;
			$pryzlib::bitIchi >>= 3;	# bIɃoCgPʂɂB
			($LEN, $NLEN)
				= unpack('v2', substr($$pryzlib::data, $pryzlib::bitIchi, 4));
			$pryzlib::bitIchi  += 4;	# LENNLEN̕B
			if($LEN + $NLEN != 0xffff)
			{
				$pryzlib::errorMessage = sprintf("LEN+NLEN0xFFFFɔ (%04X/%04X)B", $LEN, $NLEN);
				return 0;
			}
			$$kaeriData .= substr($$pryzlib::data, $pryzlib::bitIchi, $LEN);
			$pryzlib::bitIchi  += $LEN;
			$pryzlib::bitIchi <<= 3;	# ēxrbgPʂɁB
		}
		else
		{
			# rbge[u𓾂B
			if   ($BTYPE == 1)	# ÓIB
			{
				&SHuffmanTable(\@litNagasaTable, \@disNagasaTable);
			}
			elsif($BTYPE == 2)	# IB
			{
				return 0 if(!&DHuffmanTable(\@litNagasaTable, \@disNagasaTable));
			}
			else
			{
				$pryzlib::errorMessage = "sBTYPE ($BTYPE)B";
				return 0;
			}

			# e/pR[he[uB
			%litHuffmanTable = ();
			&HuffmanTableTsukuru(\%litHuffmanTable
				, \$litSaitanBit, \$litSaichooBit, \@litNagasaTable, 288);

			# pR[he[uB
			%disHuffmanTable = ();
			&HuffmanTableTsukuru(\%disHuffmanTable
				, \$disSaitanBit, \$disSaichooBit, \@disNagasaTable, 32);

			print "Loop-in, " if($pryzlib::debug);

			while(1)	# ̃ubŇB
			{
				# e/ǂݍށB
				$huff = unpack('V'
					, substr($$pryzlib::data, $pryzlib::bitIchi >> 3, 4))
					>> ($pryzlib::bitIchi & 7);

				for($bitchoo = $litSaitanBit; $bitchoo <= $litSaichooBit; $bitchoo++)
				{
					$masked = $huff & $pryzlib::masks[$bitchoo];
					$mozhi  = $litHuffmanTable{$masked};
					if($mozhi && $bitchoo == $litNagasaTable[$mozhi - 1])
					{
						$pryzlib::bitIchi += $bitchoo;
						$mozhi--;
						goto MozhiCodeFound;
					}		# goto͂ႠȂȂBfor甲
				}			# RifŔfȂĖʂ̋ɂ݂₵B
				return &HuffmanArahenError(0, $huff);
				MozhiCodeFound:

				if($mozhi < 256)
				{
					$$kaeriData .= pack('C', $mozhi);
					next;
				}
				last if($mozhi == 256);

				# ݈ʒu璷𓾂(͈257`285)B
				if   ($mozhi <  265)	# 257-264.
				{
					$nagasa = $mozhi - 254;
				}
				elsif($mozhi == 285)
				{
					$nagasa = 258;
				}
				elsif($mozhi >  285)
				{
					$pryzlib::errorMessage = "͈͂𒴂 ($nagasa)B";
					return 0;
				}
				else	# 265-284.
				{
					$ex    = ($mozhi - 261) >> 2;
					$atai  = (1 << ($ex + 2)) + 3;
					$atai += (1 << $ex) * (($mozhi - 265) & 3);

					# grbg̓ǂݏoB
					return &ShuutanError(0)
						if($pryzlib::bitIchi + $ex > $pryzlib::sooBitSuu);

					$kakuchoo = unpack('V', substr($$pryzlib::data, $pryzlib::bitIchi >> 3, 4)) >> ($pryzlib::bitIchi & 7);
					$pryzlib::bitIchi += $ex;
					$kakuchoo &= $pryzlib::masks[$ex];

					$nagasa = $atai + $kakuchoo;
				}

				# ǂݍށB
				$huff = unpack('V'
					, substr($$pryzlib::data, $pryzlib::bitIchi >> 3, 4))
					>> ($pryzlib::bitIchi & 7);

				for($bitchoo = $disSaitanBit; $bitchoo <= $disSaichooBit; $bitchoo++)
				{
					$masked = $huff & $pryzlib::masks[$bitchoo];
					$kyori  = $disHuffmanTable{$masked};
					if($kyori && $bitchoo == $disNagasaTable[$kyori - 1])
					{
						$pryzlib::bitIchi += $bitchoo;
						$kyori--;
						goto KyoriCodeFound;
					}
				}
				return &HuffmanArahenError(0, $huff);
				KyoriCodeFound:

				# ݈ʒű𓾂B
				if($kyori < 4)
				{
					$kyori++;
				}
				else
				{
					$ex    = ($kyori - 2) >> 1;
					$atai  = (1 << ($ex + 1)) + 1;
					$atai += (1 << $ex) * ($kyori & 1);

					# grbg̓ǂݏoB
					return &ShuutanError(0)
						if($pryzlib::bitIchi + $ex > $pryzlib::sooBitSuu);

					$kakuchoo = unpack('V', substr($$pryzlib::data, $pryzlib::bitIchi >> 3, 4)) >> ($pryzlib::bitIchi & 7);
					$pryzlib::bitIchi += $ex;
					$kakuchoo &= $pryzlib::masks[$ex];

					$kyori = $atai + $kakuchoo;
				}

				$shippo = substr($$kaeriData, -$kyori);
				while($nagasa > $kyori)
				{
					$$kaeriData .= $shippo;
					$nagasa -= $kyori;
				}
				$$kaeriData .= substr($shippo, 0, $nagasa);
			}
			print "Loop-out." if($pryzlib::debug);
		}
		return 1 if($BFINAL);		# B
	}
}

1;
__END__

;#--------------------------------------------------------------------
##
##  牺͍폜ĂSł
##
##--------------------------------------------------------------------
##
##  XV
##
##  ⏕CuF
##
##    Version 1.0 beta1 (2004/ 6/13)
##      pngren.pl 2.ẍʌJłɕt`łJB
##
##  ZlibfR[hCuF
##
##    Version 0.1b1 (2000/10/25)
##      PNGJE^p摜쐬XNvgɓĂŁB
##
##    Version 0.7 (2004/ 6/ 3)
##      0.1b1BR[h̎擾@ςA悭g֐ɗ̓C
##      C邱ƂŁA0.1b1ōő600%̍ɐB
##
##  Version 1.0 (2004/ 6/20)
##      ⏕CuzlibfR[hCuƂ܂Ƃ߂ɂ
##      [XB
##
##  Version 1.0.1 (2004/ 6/22)
##      CachePNG֐̑3Ƒ4i܂ł͔J̈jƂ
##      ւŁA3ʌJB
##
##--------------------------------------------------------------------
