#-------------------------------------------------------------------------------
#	FILE	:	gifpig.pl
#	ABSTRACT:	fheFϊCu
#	CREATE	:	2000/12/20
#	AUTHOR	:	Nakano Mamoru (ANON.GRAFIX)
#	CONTACT	:	65535@flashmail.com
#	VERSION	:	1.00.00
#	UPDATE	:	Ver.1.FE.00	2000/01/08 Ń[X
#	UPDATE	:	Ver.1.00.00 2000/01/18 tB^[@\ǉ
#	UPDATE	:	Ver.1.00.01 2000/02/08 gifdog ̊֐̍Ō exit Ă̂폜
#				Rg폜邱ƂŎ኱̃t@Cyʉ}
#===============================================================================
package gifdog;
#$OUTPUT_FILE = "out2.gif";
#	local($DM) = 0x09;	#wiF`		wiƂ͂
#	local($DM) = 0x0d;	#̂܂܎c		011-1	uN
#	local($DM) = 0x04;	#Ỏ摜`		001-0	wi
#	local($DM) = 0x05;	#őÔc	001-1	тƃuN͂Ȃ

local(@GifHeader) = ();
local(@Blocks) = ();
#===============================================================================
sub gifdog(*;*;*;*){
	(local(*files),local(*pos),local(*delay),local(*coleffect)) = @_;
	my $GifImage;
	push(@pos,"-,0") if (!@pos);
	my($BlockCount) = 0;
	my($ScreenWidth) = my($ScreenHeight) = 0;
	my($LeftPos) = 0;
	local(%Dum);
	my($FrameCount) = my($AnimeFlg) = 0;
	local(%Anime);
	my($DelayTime) = 0;
	my($PosX,$PosY,$PosLeft,$PosRight,$PosTop,$PosBottom);
	my($ColEffect) = '';
	$Anime{'ExtensionIntroducer'} = 0x21 if (@delay);
	foreach $fname (@files){
		%GifHeader = ();
		local($rb) = ();
		$szbuf = &read_gif($fname, *rb);
		my($rp) = &get_Header(*GifHeader, *rb);
		$FrameCount = 0;
		$AnimeFlg = 0;

		$ColEffect = shift(@coleffect) if (@coleffect);

		# \ʒuZo
		($PosX, $PosY) = split(/,/,shift(@pos)) if (@pos);
		$PosLeft = ($PosX eq "-") ? $PosRight  : $PosX;
		$PosTop =  ($PosY eq "-") ? $PosBottom : $PosY;
		$PosRight  = $PosLeft + $GifHeader{'LogicalScreenWidth'};
		$PosBottom = $PosTop  + $GifHeader{'LogicalScreenHeight'};
		$ScreenWidth  = $PosRight  if ($ScreenWidth  < $PosRight);
		$ScreenHeight = $PosBottom if ($ScreenHeight < $PosBottom);
		$DelayTime = shift(@delay) if (@delay);
		while(1){	#read black
			last if ($rp >= $szbuf);
			my($BlockType) = ord(substr($rb, $rp, 1));
			last if ($BlockType == 0x3b);	#Trailer
			if ($BlockType == 0x2c){		#ImageBlock
				$Blocks[$BlockCount]{'dum'} = 0;
				*image = $Blocks[$BlockCount];
				$rp = &get_ImageBlock(*image, *rb, $rp);
				$image{'ImageLeftPosition'} += $PosLeft;	#[ʒu
				$image{'ImageTopPosition'} += $PosTop;	#[ʒu
				# Ƃ肠[JJ[e[u
				$image{'ColorResolution'} = $GifHeader{'ColorResolution'};
				$image{'PackedFields'} = $GifHeader{'PackedFields'};
				if (!$image{"LocalColorTableFlag"}){
					$image{"LocalColorTableFlag"} = 1;
					$image{'SLCT'}     = $GifHeader{'SGCT'};
					$image{'SortFlag'} = $GifHeader{'SortFlag'};
					$image{'IBPackedFields'} = pack_bit("1,1,1,2,3",@image{
						"LocalColorTableFlag",	#Local Color Table݂ꍇ1
						"InterlaceFlag",		#C^[Xꍇ1
						"SortFlag",				#Local Color Table\[gĂꍇ1
						"Reserved",				#2
						"SLCT",					#3
					});

					$image{'LocalColorTable'} = $GifHeader{'GlobalColorTable'};
				}
				&color_effect(\$image{'LocalColorTable'},$ColEffect);

				# fbd t
				*gce = $Blocks[$BlockCount];
				if ($gce{'GraphicControlLabel'} eq ''){
					@gce{
						"ExtensionIntroducer",	#0x21 Œl
						"GraphicControlLabel",	#0xf9 Œl
						"BlockSize",			#0x04 Œl
						"GCEPackedFields",			#
						"DelayTime",			#\ۂ̒x(1001bP)
						"TransparentColorIndex",#ߏF̃CfbNX
						"BlockTerminator",		#0x00 Œl
					} = (0x21,0xf9,0x04,0x04,0x00,0x00,0x00,0x00);
				}
				# Aj
				$image{'AnimeFlg'} = $AnimeFlg;
				$image{'FrameNum'} = $FrameCount++;
				$image{'DelayTime'} += $DelayTime if (!$image{'FrameNum'});

				$BlockCount++;
			}elsif ($BlockType == 0x21){
				my($Label) = ord(substr($rb, $rp + 1, 1));
				if ($Label == 0xf9){
					$Blocks[$BlockCount]{'dum'} = 0;
					*gce = $Blocks[$BlockCount];
					$rp = &get_GraphicControlExtension(*gce, *rb, $rp);
				}elsif ($Label == 0xfe){
					$rp = &get_CommentExtension(*Dum, *rb, $rp);
				}elsif ($Label == 0x01){
					$rp = &get_PlainTextExtension(*Dum, *rb, $rp);
				}elsif ($Label == 0xff){
					$rp = &get_ApplicationExtension(*Anime, *rb, $rp);
					$AnimeFlg = 1;
				}
			}else{
				return "Unknown file format";
			}
		}
	}
	$GifHeader{'Version'} = "89a";	#89a o
	$GifHeader{'LogicalScreenWidth'} = $ScreenWidth;
	$GifHeader{'LogicalScreenHeight'} = $ScreenHeight;

	&sub_lct();		#J[e[u̍œK
	

	$GifHeader{'PackedFields'} &= ~0x87			#local color table only
		if (!$GifHeader{'GlobalColorTableFlag'});
	$GifImage = pack("a3a3SSCCC", @GifHeader{
		"Signature",			#AXL[ "GIF" 
		"Version",				#AXL[ "87a", "89a" 
		"LogicalScreenWidth",	#GIF摜Ŝ̉
		"LogicalScreenHeight",	#GIF摜Ŝ̍
		"PackedFields",
		"BackgroundColorIndex",	#wiF̃CfbNX
		"PixelAspectRatio",		#sNZ̏c
	});
	$GifImage .= $GifHeader{'GlobalColorTable'}
		if ($GifHeader{'GlobalColorTableFlag'});
	$GifImage .= pack("C*",0x21,0xfe,0x16,0x67,0x69,0x66,0x64,0x6f,0x67,0x20,0x62,0x79,0x20,0x41,0x4e,0x4f,0x4e,0x2d,0x47,0x52,0x41,0x46,0x49,0x58,0x00,0x00);
	if ($Anime{'ExtensionIntroducer'} ne ''){
		$GifImage .= pack("C*",0x21,0xff,0x0b,0x4e,0x45,0x54,0x53,0x43,0x41,0x50,0x45,0x32,0x2e,0x30,0x03,0x01,0x00,0x00,0x00);
		&sort_block();		#Aj[Vp̔zς
	}
	for ($i = 0; $i < @Blocks; $i++) {
		$GifImage .= pack("CCCCSCC", @{$Blocks[$i]}{
			"ExtensionIntroducer",	#0x21 Œl
			"GraphicControlLabel",	#0xf9 Œl
			"BlockSize",			#0x04 Œl
			"GCEPackedFields",			#
			"DelayTime",			#\ۂ̒x(1001bP)
			"TransparentColorIndex",#ߏF̃CfbNX
			"BlockTerminator",		#0x00 Œl
		});
		$GifImage .= pack("CSSSSC", @{$Blocks[$i]}{
			"ImageSeparator",		#0x2c ̌ŒlB 
			"ImageLeftPosition",	#[Έʒu
			"ImageTopPosition",		#[Έʒu
			"ImageWidth",			#
			"ImageHeight",			#c
			"IBPackedFields",			#
		});
		$GifImage .= $Blocks[$i]{'LocalColorTable'}
			if ($Blocks[$i]{"LocalColorTableFlag"});
		$GifImage .= pack("C", $Blocks[$i]{"LzwMinimumCodeSize"});
		$GifImage .= $Blocks[$i]{"Image"};
	}
	$GifImage .= pack("C", 0x3b);

#	if ($OUTPUT_FILE eq ''){
#		binmode(STDOUT);
#		print "Content-type: image/gif\n\n";
#		print $GifImage;
#	}else{
#		open(OUT, "> $OUTPUT_FILE");
#		binmode(OUT);
#		print OUT $GifImage;
#		close(OUT);
#	}
	return $GifImage;
}

#-------------------------------------------------------------------------------
sub error(@){
	my $et = shift @_;
	my @es = @_;
	print "Content-type: text/html\n\n";
	print "<H2>Error:$et</H2>";
	map{print "<LI>$_" }@es;
	exit;
}
#===============================================================================
sub color_effect($$){
	local *block_lct = shift @_;
	my($sparam) = @_;
	return if ($sparam eq '');
	my(%filters) = (
		reverse=>*reverse_filter,	#K̔]
		hsb=>*hsb_filter,			#Fƍʓx
		twotone=>*twotone_filter,	#QK
		grayscale=>*gs_filter,		#O[XP[iZsAj
		gamma=>*gamma_filter,		#␳
	);



	my $len = length($block_lct);
	my $pos = 0;
	my $lct = '';
	local @para = ();
	my $cnt = 0;
	foreach (split(/\;/,$sparam)){
		my($func,$s) = split(/\(/);
		$para[$cnt]{'func'} = $func;
		$s =~s/\)//;
		@{$para[$cnt]{'opt'}} = split(/\,/,$s);
		$cnt++;
	}
	while ($pos < $len){
		my($rgb_s) = substr($block_lct, $pos, 3);
		$pos += 3;
		my($r,$g,$b) = unpack("C*", $rgb_s);
		for($cnt = 0; $cnt < @para; $cnt++){
			*opt = $para[$cnt]{'opt'};
			$func = $para[$cnt]{'func'};
			next if ($filters{$func} eq '');
			($r,$g,$b) = &{$filters{$func}}($r,$g,$b,@opt);
		}
		$lct .= pack("C*",$r,$g,$b);
	}
	$block_lct = $lct;
}
sub reverse_filter($$$){
	return map{255-$_}@_;
}
sub hsb_filter($$$;$;$;$){
	my($r,$g,$b,$vh,$vs,$vb) = @_;
	my($h,$s,$b2) = &rgb2hsb($r,$g,$b);
	return &hsb2rgb($h+$vh, $s+$vs, $b2+$vb);
}
sub twotone_filter($$$;$;$$){
	my($r,$g,$b,$thresh,$black,$white) = @_;
	$thresh ||= 0x88;
	$black ||= "#000000";
	$white ||= "#ffffff";
	my($y ,$u, $v) = &rgb2yuv($r,$g,$b);
	return &rgbstr2array($black) if ($y < $thresh);
	return &rgbstr2array($white)
}
sub gs_filter($$$;$){
	my($r,$g,$b,$col) = @_;
	$col ||= "#ffffff";
	my($y ,$u, $v) = &rgb2yuv($r,$g,$b);
	my($h,$s,$b2) =	&rgb2hsb(&rgbstr2array($col));
	return &hsb2rgb($h,$s,$y/2.55);
}
sub gamma_filter($$$$){
	my($r,$g,$b,$gamma) = @_;
	$gamma ||= 1;
	$r = int(255*(($r/255)**(1/$gamma)));
	$g = int(255*(($g/255)**(1/$gamma)));
	$b = int(255*(($b/255)**(1/$gamma)));
	return ($r,$g,$b);
}
#Ql	http://www.mis.med.akita-u.ac.jp/~kata/image/index-j.html
sub rgb2yuv($$$){
	my($r,$g,$b) = @_;
	my $y = int(0.299*$r + 0.587*$g + 0.114*$b);
	my $u = int(-0.169 * $r -0.3316 *$g + 0.500 *$b);
	my $v = int(0.500 *$r - 0.4186*$g -0.0813 *$b);
	return ($y ,$u, $v);
}

sub hsb2gray($$$){
	my($h,$s,$b2) = @_;
	my(@gst) = (130,248,220,229,70,145,130);
	@gst = map{$_ / 2.55}@gst;
	my $n = int($h / 60);
	my $alpha = $gst[$n] + ($gst[$n+1] - $gst[$n]) * ($h % 60) / 60;
	return int(((100-$s)*(100-$alpha)/100 + $alpha)/100 * $b2 * 2.55);
}
sub rgbstr2array($){
	my($srgb,) = @_;
	$srgb =~ s/#//g;
	return (
		hex(substr($srgb, 0, 2)),
		hex(substr($srgb, 2, 2)),
		hex(substr($srgb, 4, 2))
	);
}
#================================================================================
sub hsb2rgb($$$){
    my($h,$s,$b,) = @_;
    $h %= 360;
    $s = 100 if ($s > 100);
    $s = 0 if ($s < 0);
    $b = 100 if ($b > 100);
    $b = 0 if ($b < 0);
    my($n) = int($h / 60);
    my($p) = ($n & 1) ? ((60 - ($h % 60)) / 60) : (($h % 60) / 60);
    my(@val) = ();
    $val[0] = int(255 * ($b / 100));
    $val[2] = int($val[0] * ((100 - $s) / 100));
    $val[1] = int(($val[0] - $val[2]) * $p + $val[2]);
    my(@rot) = (0,1,2,2,1,0,0,1,2,2,1,0);
    return (
        $val[$rot[$n + 0]],
        $val[$rot[$n + 4]],
        $val[$rot[$n + 2]]  );
}
#================================================================================
sub rgb2hsb(){
	my(%rgb) = ();
	@rgb{'R','G','B'} = @_;
	my(%HSB);
	my($c) = my($sorted) = '';
	my(@rgb_val) = ();
	foreach $c (sort{$rgb{$b} <=> $rgb{$a}} keys %rgb){
		$sorted .= $c;
		push(@rgb_val, $rgb{$c}); 
	}
	@h_offset{'RGB','GRB','GBR','BGR','BRG','RBG'} = (0..5);
	if ($rgb_val[0] ne $rgb_val[2]){
		$HSB{'H'} = int(60*($rgb_val[1]-$rgb_val[2])/($rgb_val[0]-$rgb_val[2]))
			*(($h_offset{$sorted}&1)?-1:+1)
			+ int(($h_offset{$sorted}+1)/2)*120;
	}else{
		$HSB{'H'} = 0;
	}
	if ($rgb_val[0] > 0){
		$HSB{'S'} = int(100 - 100 * $rgb_val[2] / $rgb_val[0]);
	}else{
		$HSB{'S'} = 0;
	}
	$HSB{'B'} = int(100 * $rgb_val[0] / 255);
	return ($HSB{'H'},$HSB{'S'},$HSB{'B'});
}
#===============================================================================
sub sub_lct(){
	my(@suf) = ();
	for (my($lp1) = 0; $lp1 < @Blocks; $lp1++){
		next if ($suf[$lp1]);
		$lct = $Blocks[$lp1]{'LocalColorTable'};
		for (my($lp2) = $lp1; $lp2 < @Blocks; $lp2++){
			$suf[$lp2] = $lp1
				if ($lct eq $Blocks[$lp2]{'LocalColorTable'});
		}
	}
	my(%srt) = ();
	map{$srt{$_}++}@suf;
	my($key);
	foreach $key (keys %srt){
		$srt{$key} = $srt{$key} * length($Blocks[$key]{'SizeOfLocalColorTable'});
	}
	my(@sufs) = sort {$srt{$a} cmp $srt{$b}} keys %srt;
	my($max) = pop(@sufs);
	$image = $Blocks[$max];
	$GifHeader{'PackedFields'}     = $Blocks[$max]{'PackedFields'};
	$GifHeader{'GlobalColorTable'} = $Blocks[$max]{'LocalColorTable'};
	my($lct) = $Blocks[$max]{'LocalColorTable'};
	my($p);
	foreach $p (@Blocks){
		if (${$p}{'LocalColorTable'} eq $lct){
			${$p}{"LocalColorTableFlag"} = 0;
			${$p}{'LocalColorTable'} = '';
			${$p}{'IBPackedFields'} &= ~0xa7;
		}
	}
}
#===============================================================================
sub sort_block(){
	if ($DM ne ''){		#Aj[Vt[̕`惂[hύX
		for (my($lp) = 0; $lp < @Blocks; $lp++){
			if ($Blocks[$lp]{'DelayTime'}){
				$Blocks[$lp]{'GCEPackedFields'} &= ~0x1d;
				$Blocks[$lp]{'GCEPackedFields'} |= $DM;
			}else{
		#		$Blocks[$lp]{'GCEPackedFields'} &= ~0x1d;
		#		$Blocks[$lp]{'GCEPackedFields'} |= 0x00;
			}
		}
	}
	my(@Sorted) = ();
	foreach $p (@Blocks){
		if ((${$p}{'AnimeFlg'})&&(${$p}{'DelayTime'} != 0)){
			push(@anime, $p);
		}else{
			push(@Sorted, $p);
		}
	}
	@Blocks = @anime;
	my($delay) = 0;
	local(%srt) = ();
	for (my($lp) = 0; $lp < @Blocks; $lp++){
		if ($Blocks[$lp]{'FrameNum'} == 0){
			$delay = 0;
		}
		$Blocks[$lp]{'StartTime'} = $delay;
		$delay += $Blocks[$lp]{'DelayTime'};
		$srt{$lp} = $delay;
	}
	my(@sufs) = sort {$srt{$a} cmp $srt{$b}} keys %srt;
	$delay = 0;
	$cnt = 0;
	foreach $suf (reverse @sufs){
		if ($cnt++){
			$Blocks[$suf]{'DelayTime'} = $delay - $Blocks[$suf]{'StartTime'};
		}
		$delay = $Blocks[$suf]{'StartTime'};
	}
	foreach $suf (@sufs){
		push(@Sorted,$Blocks[$suf]);
	}
	@Blocks = @Sorted;
}
#===============================================================================
sub read_gif($$){
	(my($file),local(*buf)) = @_;
	my($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat($file);
	return 0 if (!$size);
	open(IN, "$file");
	binmode(IN);
	sysread(IN, $buf, $size);
	close(IN);
	return $size;
}
#===============================================================================
sub get_Header(){
	(local(*dst),local(*buf),) = @_;
	my($rp) = 0;
	my($rdsz) = 13;
	my($str) = substr($buf, $rp, $rdsz);
	$rp += $rdsz;
	@dst{
		"Signature",			#AXL[ "GIF" 
		"Version",				#AXL[ "87a", "89a" 
		"LogicalScreenWidth",	#GIF摜Ŝ̉
		"LogicalScreenHeight",	#GIF摜Ŝ̍
		"PackedFields",
		"BackgroundColorIndex",	#wiF̃CfbNX
		"PixelAspectRatio",		#sNZ̏c
	} = unpack("a3,a3,S,S,C,C,C",$str);

	@dst{						#PackedFields
		"GlobalColorTableFlag",	#Global Color Table݂ꍇ1
		"ColorResolution",		#摜1hbg\킷̂ɕKvȃrbg
		"SortFlag",				#Global Color Table\[gĂꍇ1
		"SGCT",
	} = &unpack_bit("1,3,1,3",$dst{'PackedFields'});
	$dst{'SizeOfGlobalColorTable'} = 0;

	if ($dst{'GlobalColorTableFlag'}) {
		$rdsz = $dst{'SizeOfGlobalColorTable'} = (2 ** ($dst{'SGCT'} + 1)) * 3;
		$dst{'GlobalColorTable'} = substr($buf, $rp, $rdsz);
		$rp += $rdsz;
	}
	return $rp;
}
#===============================================================================
sub get_ImageBlock(){
	(local(*dst),local(*buf),my($rp),) = @_;
	my($rdsz);
	my($str) = substr($buf, $rp, $rdsz=10);
	$rp += $rdsz;
	@dst{
		"ImageSeparator",		#0x2c ̌ŒlB 
		"ImageLeftPosition",	#[Έʒu
		"ImageTopPosition",		#[Έʒu
		"ImageWidth",			#
		"ImageHeight",			#c
		"IBPackedFields",			#
	} = unpack("C,S,S,S,S",$str);
	@dst{
		"LocalColorTableFlag",	#Local Color Table݂ꍇ1
		"InterlaceFlag",		#C^[Xꍇ1
		"SortFlag",				#Local Color Table\[gĂꍇ1
		"Reserved",				#2
		"SLCT",					#3
	} = &unpack_bit("1,1,1,2,3",$dst{'IBPackedFields'});
	$dst{'SizeOfLocalColorTable'} = 0;

	if ($dst{'LocalColorTableFlag'}) {
		$rdsz = $dst{'SizeOfLocalColorTable'} = (2 ** ($dst{'SLCT'} + 1)) * 3;
		$dst{'LocalColorTable'} = substr($buf, $rp, $rdsz);
		$rp += $rdsz;
	}
	$dst{"LzwMinimumCodeSize"} = ord(substr($buf, $rp, $rdsz = 1));
	$rp += $rdsz;
	return &get_DataSubBlock(\$dst{'Image'}, *buf, $rp);
}
#===============================================================================
sub get_GraphicControlExtension {
	(local(*dst),local(*buf),my($rp),) = @_;
	my($rdsz);
	my($str) = substr($buf, $rp, $rdsz=8);
	$rp += $rdsz;
	@dst{
		"ExtensionIntroducer",	#0x21 Œl
		"GraphicControlLabel",	#0xf9 Œl
		"BlockSize",			#0x04 Œl
		"GCEPackedFields",			#
		"DelayTime",			#\ۂ̒x(1001bP)
		"TransparentColorIndex",#ߏF̃CfbNX
		"BlockTerminator",		#0x00 Œl
	} = unpack("C,C,C,C,S,C,C", $str);
	@dst{
		"Reserved",				#gp
		"DisposalMethod",		#e
		"UserInputFlag",		#e
		"TransparentColorFlag",	#ߏsꍇ1
	} = &unpack_bit("3,3,1,1",$dst{'GCEPackedFields'});
	return $rp;
}
#===============================================================================
sub get_CommentExtension {
	(local(*dst),local(*buf),my($rp),) = @_;
	my($rdsz);
	my($str) = substr($buf, $rp, $rdsz=2);
	$rp += $rdsz;
	@dst{
		"ExtensionIntroducer",	#0x21 Œl
		"CommentLabel"			#0xfe Œl
	} = unpack("C,C", $str);
	return &get_DataSubBlock(\$dst{'Comment'}, *buf, $rp);
}
#===============================================================================
sub get_PlainTextExtension {
	(local(*dst),local(*buf),my($rp),) = @_;
	my($rdsz);
	my($str) = substr($buf, $rp, $rdsz=15);
	$rp += $rdsz;
	@dst{
		"ExtensionIntroducer",			#0x21 Œl
		"PlainTextLabel",				#0x01 Œl
		"BlockSize",					#0x0c ̌Œl
		"TextGridLeftPosition",			#e
		"TextGridTopPosition",			#e
		"TextGridWidth",				#e
		"TextGridHeight",				#e
		"CharacterCellWidth",			#e
		"CharacterCellHeight",			#e
		"TextForegroundColorIndex",		#e
		"TextBackgroundColorIndex",		#e
	} = unpack("C,C,C,S,S,S,S,C,C,C,C",$str);
	return &get_DataSubBlock(\$dst{'Text'}, *buf, $rp);
}
#===============================================================================
sub get_ApplicationExtension($$$) {
	(local(*dst),local(*buf),my($rp),) = @_;
	my($rdsz);
	my($str) = substr($buf, $rp, $rdsz=14);
	$rp += $rdsz;
	@dst{
		"ExtensionIntroducer",			#0x21 Œl
		"ExtentionLabel",				#0xff Œl
		"BlockSize",					#0x0b ̌Œl
		"ApplicationIdentifire",		#e(8B)
		"ApplicationAuthenticationCode",#e(3B)
	} = unpack("C,C,C,a8,a3",$str);
	return &get_DataSubBlock(\$dst{'ApplicationData'}, *buf, $rp);
}
#===============================================================================
sub get_DataSubBlock($$$) {
	(local(*dst), local(*buf), my($rp)) = @_;
	my($rdsz) = 0;
	my($blick_size);
	while ($blick_size = ord(substr($buf, $rp + $rdsz, 1))) {
		$rdsz += (1 + $blick_size);	#BlockSize + Data
	}
	$rdsz += 1;			#add Block Terminator
	$dst = substr($buf, $rp, $rdsz);
	return $rp + $rdsz;
}
#===============================================================================
sub unpack_bit($$){
	my(@s) = split(/,/,$_[0]);
	my($c) = $_[1];
	my($lp1,$lp2,@v);
	foreach $lp2 (@s){
		for ($lp2 = @s[$lp1]; $lp2; $lp2--){
			$v[$lp1] <<= 1;
			$v[$lp1] |= ($c & 0x80) ? 1 : 0;
			$c <<= 1;
		}
		$lp1++
	}
	return @v;
}
#===============================================================================
sub pack_bit($$){
	my(@s) = split(/,/,shift(@_));
	my(@v) = @_;
	my($shft) = 8;
	my($val) = 0;
	foreach (@s){
		$shft -= $_;
		$val |= shift(@v) << $shft;
	}
	return $val;
}

1


