package leaf;

#--------------------------------------------------------------------------
# SGF ֘ATOOL  [IgoMain]
#--------------------------------------------------------------------------
$gifDir = '15';
$usrDir = '15';
$pngDir = 'png';
$pngFile = 'out.png';
$gifFile = 'temp.gif';

$AKI =  0;
$KURO = 1;
$SIRO = 5;
$HASI = -50;
$esTable = 'zabcdefghijklmnopqrstuvwxyz';
$zaTable = 'ZABCDEFGHJKLMNOPQRST';
$suuTable = "PQRSTUVWX"; 
$banSize = 19;
$absLine = $banSize + 2;
$kuroSaki = 1;
$haiti = 0;
$haiKuro = 0;
$allMoves = 0;
$extLine = 2;
$autoFix = 0;
$showMov = 0;
$showNum = 0;
$outImg = 0;
$endMark = 0;

$xEnd = 41;  
$yEnd = 379;
$xMin = 0;  
$yMin = 0;
$xMax = 0;  
$yMax = 0; 
#$mese = "Test\n";

@moves = ();
@col = ();
@ed  = ();

sub sgf2dia
{
    my ($sgf, $fix, $mov, $num, $out, $pdir, $pname, $gdir, $gname, $mark, $udir, $xin, $yin, $xax, $yax, $mode) = @_;

    $autoFix = $fix; 
    $showMov = $mov; 
    $showNum = $num;
    $outImg  = $out;
    if($pdir)  { $pngDir  = $pdir; }  
    if($pname) { $pngFile = $pname; }  
    if($gdir)  { $gifDir  = $gdir; }  
    if($gname) { $gifFile = $gname; }  
    $endMark = $mark; 
    if($udir)  { $usrDir  = $udir; } 
    
    if($#col < 0) 
    { 
       if($xin)  { $xMin = $xin; }  # ͈͎w    
       if($yin)  { $yMin = $yin; }   
       if($xax)  { $xMax = $xax; }    
       if($yax)  { $yMax = $yax; }  
       readSgf($sgf);   # ǂ(̂) 
    }

    if($mode eq 'pngren')    { pngRenGoban(); }  
    elsif($mode eq 'gifdog') { gifDogGoban(); }  
    elsif($mode eq 'gif')    { gifGoban(); }   
    else { txtGoban(); }  
}

sub readSgf
{
    my $sgf = $_[0];
    my (@BW, @AB, @AW);

    @moves = (); 
    @col = ();
    @ed  = ();

    if($sgf =~ /\.sgf$/) # t@Cǂݍ 
    {
        if(open(DB, "$sgf"))
        {  
            while ($xy = <DB>) { $sgf .= $xy; } 
            close(DB);           
        }
    }

    if(index($sgf, '') > -1) # eLXgՂǂ
    { 
        readTextGoban($sgf);
        return;
    }

    foreach (split ";", $sgf) 
    {
        if(/^(B|W)\[([a-z][a-z])\]/)
        {           
            if(@BW == 0) #  
            { 
                if($1 eq "W") { $kuroSaki = 0; }
                         else { $kuroSaki = 1; }
            }

            push @BW,$2;
        } 
       
        if(/(AB[a-s\[\]\n\r]+)/)
        {
           my $AB = $1;
           $AB =~ s/(AB|\[|\n)//g;
           @AB = split(/\]/, $AB);
           #hw# P pop @AB Ƃ AB̍Ō̐΂
           pop @AB unless($AB[$#AB] =~ /\w\w/); 
        }

        if(/(AW[a-s\[\]\n\r]+)/)
        {
            my $AW = $1;
            $AW =~ s/(AW|\[|\n)//g; 
            @AW = split(/\]/, $AW);
            #hw#
            pop @AW unless($AW[$#AW] =~ /\w\w/); 
        }

        if(/SZ\[([^\]]+)\]/) { $banSize = $1; }  
    }

    init();
   
    $haiti = ($haiKuro = @AB) + @AW;
    foreach ((@AB, @AW, @BW)) { push @moves, ccPos($_); }
    $allMoves = @moves;
    datSet();  # f[^ݒ  
    shape($showMov ? $allMoves : $haiti);  # ǖʐ
}    

sub init
{
    $absLine = $banSize + 2;      
 
    my $sz = $absLine ** 2; 
    for(my $i = 0; $i < $sz; $i++) 
    {
        my $yoko = int($i / $absLine);
        my $tate = $i % $absLine;
        if($yoko == 0 || $tate == 0 || 
           $yoko > $banSize || $tate > $banSize) { push @col, $HASI; }
        else { push @col, 0; }
        
        push @ed, 0;    
    } 
}

sub datSet
{
    $xEnd = $absLine + $banSize + 1;            # XWI[l
    $yEnd = ($banSize - 1) * $absLine + 1;      # YWI[l
    
    my($xmin, $ymin, $xmax, $ymax) = autoFix(); # ͈̓`FbN
    if($xMin == 0) { $xMin = $xmin; } 
    if($yMin == 0) { $yMin = $ymin; }
   
    if ($xMax eq "@") { $xMax = $banSize; }  
    elsif($xMax == 0) { $xMax = $xmax; } 
      
    if ($yMax eq "@") { $yMax = $banSize; } 
    elsif($yMax == 0) { $yMax = $ymax; }
}

sub readTextGoban # eLXgՂǂ
{
    my (@BW, @AB, @AW);
    my $sgf = $_[0];
    $sgf =~ s/<\/?font.*?>//g; 
    $sgf =~ s/\n>/\n/g;
    $sgf =~ s/==/=/g;  
    $sgf =~ s/\] \[/\]\n\[/g;

    my $za = index($sgf, '**') + 1;  # StoneLeaf̍Wt` 
    my $line = 0, $abs = 0;  # my @arr = ((0) x 100); 
    my %tete;
    foreach (split "\n", $sgf) 
    {
        my $dat = $_; 
        if($za) 
        { 
            if(/^\d{2}(.+)\d{2}\s?$/) { $dat = $1; $mese = "$mese\n$dat"; } 
            elsif(index($dat, '=') < 0) { next; } 
        }   
 
        $dat =~ s/\s//g;

        my $len = length($dat);
        if($len < 5) { next; }
        if($abs == 0) { $abs = int($len / 2) + 2; }  

        if(index($dat, '=') > 0)
        {
            my($bb, $pp) = split(/=/, $dat, 2);
            $bb =~ s/[\[|\s]//g; 
            $pp =~ s/[\(|\)|\[|\]|\s]//g;
            
            if(length($pp) < 3) { $tete{$bb} = $tete{$pp}; } 
            elsif(length($pp) < 6) 
            {   
                if(za) # [StoneLeaf]o͌`
                {
                    my $yo = index($zaTable, substr($pp, 0, 1));  
                    my $ta = 20 - substr($pp, 1, length($pp) - 1);
                    $tete{$bb} = $yo * $abs + $ta; 
                }
                else
                {  
                    my($yo, $ta) = split(/\,/, $pp, 2);
                    $tete{$bb} = $yo * $abs + $ta; 
                }  
            }
            next;
        }
         
        $line++;
        for(my $i = 0; $i < $len; $i += 2) 
        {  
            my $pos = (int($i / 2) + 1) * $abs + $line; 
            my $tmp = substr($dat, $i, 2);    
           
               if($tmp eq '') { push @AB,$pos; }
            elsif($tmp eq '') { push @AW,$pos; }
            elsif($tmp eq 'S') { $tete{'999'} = $pos; }
            else  
            {   my $ind = int(index($suuTable, $tmp));
                if($ind > -1)  
                {  
                   $ind = int($ind / 2) + 1;  
                   $tete{$ind} = $pos;
                }   
                elsif($tmp =~ /\d{2}/) { $tete{$tmp} = $pos; }   
            }
        }     
    }
          
    for(sort { $a <=> $b } keys %tete) { push @BW,$tete{$_}; }
     
    $banSize = $abs - 2;
    init();
    $kuroSaki = (index($sgf, 'white') < 0 && index($sgf, 'p1=w') < 0) ? 1 : 0;
    $haiti = ($haiKuro = @AB) + @AW;
    foreach ((@AB, @AW, @BW)) { push @moves, $_; }
    $allMoves = @moves;

    datSet();  # f[^ݒ
    shape($showMov ? $allMoves : $haiti);  # ǖʐ
}

sub pngRenGoban  # PNGՌ
{
    my %nuki = nukiAto();  # 菇΂̔Քz  
    my $name;    
    my $endpos = ($endMark && !$showNum) ? endPos() : 0;

    for(my $i = $absLine + 1; $i < $xEnd; $i++) 
    {     
        @arr = ();

        for(my $j = 0; $j < $yEnd; $j += $absLine) 
        {    
            my $pos = $i + $j;
            if($col[$pos] < 0) { next; }
            
            my $yoko = int($pos / $absLine); 
            if($yoko < $xMin || $yoko > $xMax) { next; }

            my $tate = $pos % $absLine; 
            if($tate < $yMin || $tate > $yMax) { next; }

            my $hai = numHaiti($pos);

            if($endpos == $pos) { $name = (isKuro($allMoves - $haiti) ? png("bt") : png("wt")); }

            elsif($hai > 0 && $showNum) { $name = ($hai > $haiKuro ? png("w") : png("b")); }
   
            elsif($col[$pos] == 0) # _
            {
                if($showMov && $showNum && $nuki{$pos}) # Ղ̎菇Ε\ 
                {   
                    $name = pngMov($nuki{$pos});  
                }
                
                elsif($yoko == 1) 
                {        
                    if($tate == 1 ) { $name = png("ulc"); }
                    elsif($tate == $banSize) { $name = png("llc"); }
                    else { $name = png("ls"); }   
                }

                elsif($yoko == $banSize) 
                {   
                    if($tate == 1) { $name = png("urc"); }
                    elsif($tate == $banSize) { $name = png("lrc"); }
                    else { $name = png("rs"); }
                }

                elsif($tate == 1) { $name = png("ts"); }
               
                elsif($tate == $banSize) { $name = png("bs"); }
                
                elsif(isStar($yoko, $tate)) { $name = png("h"); }
               
                else { $name = png("p"); }  
            }

            else
            {
                my $num = moveNum($pos); # 菇ԍ

                if(!$showNum || !$num) { $name = ($col[$pos] == $KURO) ? png("b") : png("w"); } #z
                
                else { $name = pngMov($num); } #菇  
            }
            
            push @arr, $name;             
            
            if($yoko == $xMax) # E[ 
            {  
                open OUT, ">./$pngDir/yoko$tate.png";
                binmode OUT;
                select(OUT);
                &pngren::PngRen(\@arr, $pngren::ALLAUTO); 
                close OUT;
                select(STDOUT);
            }  
        }   
    }
   
    @pngs = ();
    for(my $i = $yMin; $i <= $yMax; $i++) { push @pngs, "./$pngDir/yoko$i.png"; }
    foreach(pngAru()) { push @pngs, $_; }

    open OUT, ">$pngFile";
    binmode OUT;
    select(OUT);
    &pngren::PngRen(\@pngs, $pngren::ALLAUTO, 1); 
    close OUT;
    select(STDOUT); 
   
    if($outImg) # C[Wo
    {
        $size = -s $pngFile;
        open(IN, $pngFile);
        binmode(IN);
        binmode(STDOUT);
        read(IN, $buf, $size);
        print $buf;
        close(IN);
        exit;
    }

    else
    { 
        print "[PNG BOARD]<br><br>\n<img src=$pngFile>\n<br>$aru<br><hr>";
    } 
}

sub pngAru()
{ 
    my @arrAru = ();

    if($showMov && $showNum)
    {
        my %aru = sakiAru();   
        my $str = "";  
        my $same = png('eq');   
        my $comma = png('comma');          
        my $cnt = 0; 
        my $suu = $xMax - $xMin + 1;     

        if(keys %aru > 0) # s
        {   
            @arr = ();
            for(my $i = $suu; $i > 0; $i--) { push @arr, png('blnk'); }  

            my $name = "./$pngDir/aru0.png";            
            push @arrAru, $name;
            
            open OUT, ">$name"; 
            binmode OUT;
            select(OUT);
            &pngren::PngRen(\@arr, $pngren::ALLAUTO); 
            close OUT;
            select(STDOUT); 
        }

        for(sort { $a <=> $b } keys %aru) 
        { 
            @arr = ();
            my $s1 = isKuro($_) ? png("b$_") : png("w$_");
            
            push @arr, $s1;
            push @arr, $same;

            my $pos = $aru{$_};
            my $num = moveNum($pos);
            if($num > 0 && $num < $_ && !exists $aru{$num}) 
            {    
                my $s2 = isKuro($num) ? png("b$num") : png("w$num");
                push @arr, $s2;
            }
            else
            {  
                my $yoko = png(int($pos / $absLine));
                my $tate = png($pos % $absLine); 
                push @arr, $yoko;
                push @arr, $comma;
                push @arr, $tate;
            }

            for(my $i = $suu - @arr; $i > 0; $i--) { push @arr, png('blnk'); }  

            $cnt++;
            my $name = "./$pngDir/aru$cnt.png";            
            push @arrAru, $name;
            
            open OUT, ">$name"; 
            binmode OUT;
            select(OUT);
            &pngren::PngRen(\@arr, $pngren::ALLAUTO); 
            close OUT;
            select(STDOUT); 
        }    
    }

    return @arrAru;
}

sub png 
{ 
   return "./$pngDir/$_[0].png"; 
}

sub pngMov
{
   my $num = $_[0];
   my $cr = isKuro($num) ? "b" : "w";     
   return png("$cr$num");  
}

#GIFՌ
sub gifDogGoban 
{
    local @img = ("./15/blnk.gif");
    local @pos = ("0,0"); 
    my $X = 0; 
    my $Y = 0;  
    my $haba = 15;
    my $posx = $X; 
    my $posy = $Y; 

    my %nuki = nukiAto();  # 菇΂̔Քz  
    my $name;  
    my $endpos = ($endMark && !$showNum) ? endPos() : 0;  

    for(my $i = $absLine + 1; $i < $xEnd; $i++) 
    {    
        for(my $j = 0; $j < $yEnd; $j += $absLine) 
        {    
            my $pos = $i + $j;
            if($col[$pos] < 0) { next; }
            
            my $yoko = int($pos / $absLine); 
            if($yoko < $xMin || $yoko > $xMax) { next; }

            my $tate = $pos % $absLine; 
            if($tate < $yMin || $tate > $yMax) { next; }
               
            my $hai = numHaiti($pos);

            if($endpos == $pos) { $name = (isKuro($allMoves - $haiti) ? dog("bt") : dog("wt")); }

            elsif($hai > 0 && $showNum) { $name = ($hai > $haiKuro ? dog("w") : dog("b")); }
  
            elsif($col[$pos] == 0) # _
            {
                if($showMov && $showNum && $nuki{$pos}) # Ղ̎菇Ε\ 
                {   
                    $name = dogMov($nuki{$pos});  
                }

                elsif($yoko == 1) 
                {        
                    if($tate == 1 ) { $name = dog("ulc"); }
                    elsif($tate == $banSize) { $name = dog("llc"); }
                    else { $name = dog("ls"); }   
                }

                elsif($yoko == $banSize) 
                {   
                    if($tate == 1) { $name = dog("urc"); }
                    elsif($tate == $banSize) { $name = dog("lrc"); }
                    else { $name = dog("rs"); }
                }

                elsif($tate == 1) { $name = dog("ts"); }
               
                elsif($tate == $banSize) { $name = dog("bs"); }
                
                elsif(isStar($yoko, $tate)) { $name = dog("h"); }
               
                else { $name = dog("p"); }  
            }

            else
            {
                my $num = moveNum($pos); # 菇ԍ

                if(!$showNum || !$num) { $name = ($col[$pos] == $KURO) ? dog("b") : dog("w"); } #z
                
                else { $name = dogMov($num); } #菇  
            }

            push @img, $name;
            push @pos, "$posx,$posy"; 
             
            $posx += $haba;  
            
            if($yoko == $xMax) # E[ 
            {  
                $posx = $X; 
                $posy += $haba;
            }  
        }   
    }
    
    my $aru = gifAru();

    open OUT, ">$gifFile";
    binmode OUT; #for Windows
    print OUT gifdog::gifdog(*img, *pos);  
    close OUT;

    if($outImg) # C[Wo
    {
        $size = -s $gifFile;
        open(IN, $gifFile);
        binmode(IN);
        binmode(STDOUT);
        read(IN, $buf, $size);
        print $buf;
        close(IN);
        exit;
    }

    else
    {  
        print "[GIF BOARD]<br><br>\n<img src=$gifFile>\n<br>$aru<br><hr>";
    }
}

sub dog 
{ 
   return "./$gifDir/$_[0].gif"; 
}

sub dogMov
{
    my $num = $_[0];
    my $cr = isKuro($num) ? "b" : "w"; 
    return dog($cr.$num);  
}

sub gifGoban
{
    my $tt = "<pre>\n";
    my %nuki = nukiAto();  # 菇΂̔Քz
    my $endpos = ($endMark && !$showNum) ? endPos() : 0;    

    for(my $i = $absLine + 1; $i < $xEnd; $i++) 
    {    
        for(my $j = 0; $j < $yEnd; $j += $absLine) 
        {    
            my $pos = $i + $j;
            if($col[$pos] < 0) { next; }
            
            my $yoko = int($pos / $absLine); 
            if($yoko < $xMin || $yoko > $xMax) { next; }

            my $tate = $pos % $absLine; 
            if($tate < $yMin || $tate > $yMax) { next; }
   
            my $hai = numHaiti($pos);

            if($endpos == $pos) { $tt .= (isKuro($allMoves - $haiti) ? gif("bt") : gif("wt")); }

            elsif($hai > 0 && $showNum) { $tt .= ($hai > $haiKuro ? gif("w") : gif("b")); }
  
            elsif($col[$pos] == 0) # _
            {
                if($showMov && $showNum && $nuki{$pos}) # Ղ̎菇Ε\ 
                {   
                    $tt .= gifMov($nuki{$pos});  
                }

                elsif($yoko == 1) 
                {      
                    if($tate == 1 ) { $tt .= gif("ulc"); }
                    elsif($tate == $banSize) { $tt .= gif("llc"); }
                    else { $tt .= gif("ls"); }
                }

                elsif($yoko == $banSize) 
                {   
                    if($tate == 1) { $tt .= gif("urc"); }
                    elsif($tate == $banSize) { $tt .= gif("lrc"); }
                    else { $tt .= gif("rs"); }
                }

                elsif($tate == 1) { $tt .= gif("ts"); }
               
                elsif($tate == $banSize) { $tt .= gif("bs"); }
               
                elsif(isStar($yoko, $tate)) { $tt .= gif("h"); }
               
                else { $tt .= gif("p"); }
           }

           else
           {
                my $num = moveNum($pos); # 菇ԍ

                if(!$showNum || !$num) { $tt .= ($col[$pos] == $KURO) ? gif("b") : gif("w"); } #z
              
                else { $tt .= gifMov($num); } #菇   
           }

           if($yoko == $xMax) { $tt .= "\n"; } # ՉE[  
        }   
    }

    $tt .= (gifAru() . "</pre>");
    
    my $u1 = $tt;
    $u1 =~ s/@DIR@/$gifDir/g;
    
    my $u2 = $tt;
    $u2 =~ s/@DIR@/$usrDir/g; 
    $u2 = "\n<textarea rows=10 cols=50 wrap=off >\n $u2 \n</textarea>";
 
    print "[GIF SLICE]<br><br>$u1 $u2 \n<hr>";         
}

sub gif 
{  
   return "<img src=\"@DIR@/$_[0].gif\">"; 
}

sub gifMov
{
    my $num = $_[0];
    my $cr = isKuro($num) ? "b" : "w";  

    return gif("$cr$num");  
}

sub gifAru()
{ 
    if($showMov && $showNum)
    {
        my %aru = sakiAru();   
        my $str = "";              
        
        for(sort { $a <=> $b } keys %aru) 
        { 
            my $pos = $aru{$_};
            my $num = moveNum($pos);
            my $s1 = isKuro($_) ? gif("b$_") : gif("w$_");

            if($num > 0 && $num < $_ && !exists $aru{$num}) 
            {    
                my $s2 = isKuro($num) ? gif("b$num") : gif("w$num");
                $str .= "$s1 = $s2 <br>"; 
            }
            else
            {  
                my $yoko = gif(int($pos / $absLine));
                my $tate = gif($pos % $absLine); 
                $str .= "$s1 = $yoko,$tate <br>";
            }
        }
 
        return "$str\n";    
    }

    return "";
}

sub txtGoban 
{  
    my $tt = "<pre>\n";
    my %nuki = nukiAto();  # 菇΂̔Քz    
    my $endpos = ($endMark && !$showNum) ? endPos() : 0;
  
    for(my $i = $absLine + 1; $i < $xEnd; $i++) 
    {    
        for(my $j = 0; $j < $yEnd; $j += $absLine) 
        {    
            my $pos = $i + $j;
            if($col[$pos] < 0) { next; }
            
            my $yoko = int($pos / $absLine); 
            if($yoko < $xMin || $yoko > $xMax) { next; }

            my $tate = $pos % $absLine; 
            if($tate < $yMin || $tate > $yMax) { next; }
             
            my $hai = numHaiti($pos);

            if($endpos == $pos) { $tt .= (isKuro($allMoves - $haiti) ? "" : ""); }

            elsif($hai > 0 && $showNum) { $tt .= ($hai > $haiKuro ? "" : ""); }
 
            elsif($col[$pos] == 0) # _
            {
                if($showMov && $showNum && $nuki{$pos}) # Ղ̎菇Ε\ 
                {   
                    $tt .= txtMov($nuki{$pos});  
                }

                elsif($yoko == 1) 
                {      
                    if($tate == 1 ) { $tt .= ""; }
                    elsif($tate == $banSize) { $tt .= ""; }
                    else { $tt .= ""; }
                }

                elsif($yoko == $banSize) 
                {   
                    if($tate == 1) { $tt .= ""; }
                    elsif($tate == $banSize) { $tt .= ""; }
                    else { $tt .= ""; }
                }

                elsif($tate == 1) { $tt .= ""; }
               
                elsif($tate == $banSize) { $tt .= ""; }
               
                elsif(isStar($yoko, $tate))  { $tt .= "E"; }
               
                else { $tt .= ""; }
           }

           else
           {
                my $num = moveNum($pos); # 菇ԍ

                if(!$showNum || !$num) { $tt .= ($col[$pos] == $KURO) ? "" : ""; } #z

                else { $tt .= txtMov($num); } # 菇
           }

           if($yoko == $xMax) { $tt .= "\n"; } #ՉE[  
        }   
    }

    if($showMov && $showNum)
    {
        my %aru = sakiAru();   
      
        for(sort { $a <=> $b } keys %aru) 
        { 
            my $pos = $aru{$_};
            my $num = moveNum($pos);
            
            if($num > 0 && $num < $_ && !exists $aru{$num}) { $tt .= "$_ = \($num\)\n"; }
            else
            {  
                my $yoko = int($pos / $absLine);
                my $tate = $pos % $absLine; 
                $tt .= "$_ = \[$yoko,$tate\]\n";
            }
        }     
    }

    if($kuroSaki == 0) { $tt .= "\nwhite\n"; }

    $tt .= "</pre>" ;
   
    $area = "\n<textarea rows=10 cols=50 wrap=off >\n $tt \n</textarea>";

    print "[TEXT BOARD]<br><br>$tt $area \n<hr>";    
}

sub sakiAru
{
    my %aru;
       
    for(my $i = $haiti; $i < $allMoves; $i++)
    {
        my $pos = $moves[$i];
        for(my $j = 0; $j < $i; $j++)
        {
            if($pos == $moves[$j]) { $aru{ $i - $haiti + 1 } = $pos; }
        }
    }

    return %aru;
}

sub numHaiti
{
    my $pos = $_[0];
    
    for(my $i = 0; $i < $haiti; $i++)
    {
        if ($pos == $moves[$i]) { return $i + 1; }
    }

    return 0;
}

sub txtMov
{
    my $num = $_[0];
    my $cr = isKuro($num) ? "blue>" : "red>"; 
    my $tt = "<font color=$cr"; 
    if($num < 10) { $tt .= substr($suuTable, ($num - 1) * 2, 2); } 
    elsif($num == 100) { $tt .= "S"; }
    else { $tt .= $num; } 
    
    return "$tt</font>";  
}

sub nukiAto
{
    my %tmp; 
    
    for(my $i = $allMoves - 1; $i >= $haiti; $i--)
    {
        my $pos = $moves[$i];
        if($col[$pos] == 0) { $tmp{$pos} = $i - $haiti + 1; }
    }

    return %tmp;
}

sub isKuro
{
   my $num = $_[0];

   return ($kuroSaki == $num % 2 ? 1 : 0);
}


sub autoFix
{
    if(!$autoFix) { return (1, 1, $banSize, $banSize); } 

    my($xmin, $ymin, $xmax, $ymax) = &getMinMax;
   
    if($xmin - 1 > 0) { $xmin--;  if($xmin - 1 > 0 && $extLine > 1) { $xmin--; } } 
    if($ymin - 1 > 0) { $ymin--;  if($ymin - 1 > 0 && $extLine > 1) { $ymin--; } } 
    if($xmax + 1 <= $banSize) { $xmax++; if($xmax + 1 <= $banSize && $extLine > 1) { $xmax++; } }
    if($ymax + 1 <= $banSize) { $ymax++; if($ymax + 1 <= $banSize && $extLine > 1) { $ymax++; } }
    
    return ($xmin, $ymin, $xmax, $ymax); 
}

sub getMinMax
{
    my $xmin = $banSize; 
    my $ymin = $banSize; 
    my $xmax = 1; 
    my $ymax = 1;

    for(my $i = 0; $i < $allMoves; $i++)
    {
        my $pos = $moves[$i];
        my $yoko = int($pos / $absLine);
        my $tate = $pos % $absLine;
        if($yoko < $xmin) { $xmin = $yoko; }
        if($tate < $ymin) { $ymin = $tate; }
        if($yoko > $xmax) { $xmax = $yoko; }
        if($tate > $ymax) { $ymax = $tate; }      
    }

    return ($xmin, $ymin, $xmax, $ymax); 
}

sub isStar
{
    my ($yoko, $tate) = @_;

    if($banSize == 19)
    {
        for(my $i = 1; $i < 4; $i++)
        {
            for(my $j = 1; $j < 4; $j++)
            {
                if($yoko == $j * 6 - 2 && $tate == $i * 6 - 2) { return 1; }                      
            }
        }
    }

    elsif($banSize > 10)
    {
        #if($yoko == $tate && $yoko == int($banSize / 2) + 1) { return 1; } #V 
        
        return &star4($yoko, $tate, 4);
    }

    elsif($banSize > 7)
    {
        return &star4($yoko, $tate, 3);
    }

    elsif($banSize == 7)
    {
        return ($yoko == 4 && $tate == 4) ? 1 : 0;      
    }
 
    return 0;
}

sub star4
{  
    my ($yoko, $tate, $sen) = @_;
    my $end = $banSize + 1 - $sen;

    return (($yoko == $sen && $tate == $sen) ||
            ($yoko == $sen && $tate == $end) ||
            ($yoko == $end && $tate == $sen) ||
            ($yoko == $end && $tate == $end)) ? 1 : 0; 
}

sub moveNum
{
    my $pos = $_[0];
    
    for(my $i = $haiti; $i < $allMoves; $i++)
    {
        if ($pos == $moves[$i]) { return ($i - $haiti + 1); }
    }

    return 0;
}

sub isHaiKuro
{
    my $pos = $_[0];
    
    for(my $i = 0; $i < $haiKuro; $i++)
    {
        if ($pos == $moves[$i]) { return 1; }
    }

    return 0;
}

sub shape 
{  
    my $cnt = $_[0];
    my $sz = @col; 
    for(my $i = 0; $i < $sz; $i++) { if($col[$i] > 0) { $col[$i] = 0; } }
  
    for(my $i = 0; $i < $cnt; $i++)
    {
        my $pos = $moves[$i];
        if($pos == 0) { next; }

        if($i < $haiti) # 
        { 
            $col[$pos] = ($i < $haiKuro) ? $KURO : $SIRO; 
        }

        else # 菇 
        {  
            my $iro = ($kuroSaki == ($i + 1 - $haiti) % 2) ? $KURO : $SIRO;
            $col[$pos] = $iro;
            shape1(6 - $iro, $pos);
        }
    }
}

sub shape1 
{
    my ($iro, $pos) = @_;
   
    foreach (($pos + $absLine, $pos - $absLine, $pos + 1, $pos - 1)) 
    {  
        if($col[$_] == $iro) { shape3($_, shape2($_)); } 
    }   
}

sub shape2
{  
    my $pos = $_[0];
    $ed[$pos] = 1;  

    return ($col[$pos + $absLine] == 0 || $col[$pos - $absLine] == 0 || $col[$pos + 1] == 0 || $col[$pos - 1] == 0 ||
            (!$ed[$pos + $absLine] && $col[$pos + $absLine] == $col[$pos] && !shape2($pos + $absLine)) ||
            (!$ed[$pos - $absLine] && $col[$pos - $absLine] == $col[$pos] && !shape2($pos - $absLine)) ||
            (!$ed[$pos + 1 ] && $col[$pos + 1 ] == $col[$pos] && !shape2($pos + 1)) ||
            (!$ed[$pos - 1 ] && $col[$pos - 1 ] == $col[$pos] && !shape2($pos - 1))) ? 0 : 1;
}

sub shape3 
{  
    my ($pos, $flag) = @_;
    $ed[$pos] = 0;   
    if($flag) { $col[$pos] = 0; }

    if($ed[$pos + $absLine]) { shape3($pos + $absLine, $flag); }
    if($ed[$pos - $absLine]) { shape3($pos - $absLine, $flag); }
    if($ed[$pos + 1 ]) { shape3($pos + 1, $flag); }
    if($ed[$pos - 1 ]) { shape3($pos - 1, $flag); } 
}

sub ccPos
{
    $x = index $esTable, substr($_[0], 0, 1);
    $y = index $esTable, substr($_[0], 1, 1);
    if($x < 1 || $x > $banSize || $y < 1 || $y > $banSize) { return 0; }   
    return $x * $absLine + $y; 
}

sub endPos
{
   return ($allMoves > $haiti ? $moves[$allMoves - 1] : 0);
}

1;
